SystemOrganization addCategory: #'Pier-Model-Core'!
SystemOrganization addCategory: #'Pier-Model-Magritte'!
SystemOrganization addCategory: #'Pier-Model-Kernel'!
SystemOrganization addCategory: #'Pier-Model-Persistence'!
SystemOrganization addCategory: #'Pier-Model-Structure'!
SystemOrganization addCategory: #'Pier-Model-Command'!
SystemOrganization addCategory: #'Pier-Model-Document'!
SystemOrganization addCategory: #'Pier-Model-Exception'!
SystemOrganization addCategory: #'Pier-Model-Visitor'!
SystemOrganization addCategory: #'Pier-Model-Utilities'!

MAValidationError subclass: #PRChildNotFoundError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

MAValidationError subclass: #PRDecorationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

MAValidationError subclass: #PRInvalidKernelError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

MAValidationError subclass: #PRPersistencyError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

MAValidationError subclass: #PRStructureError
	instanceVariableNames: 'structure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

PRStructureError subclass: #PRConflictingNameError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

PRStructureError subclass: #PRInvalidNestingError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

!PRInvalidNestingError class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
of: aChildStructure in: aParentStructure
	^ (self structure: aParentStructure)
		signal: aChildStructure title printString , ' can not be a child of ' , aParentStructure title printString! !

!PRStructureError class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
structure: aStructure
	^ self new
		setStructure: aStructure;
		yourself! !

!PRStructureError methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:30'!
setStructure: aStructure
	structure := aStructure! !

!PRStructureError methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
structure
	^ structure! !

Notification subclass: #PRCurrentContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Kernel'!

!PRCurrentContext commentStamp: 'lr 5/28/2006 17:06' prior: 0!
I am a dynamic variable. I answer the current context when being raised.!

!PRCurrentContext class methodsFor: 'utilities' stamp: 'lr 3/9/2006 11:30'!
use: anObject during: aBlock
	^ aBlock on: self do: [ :notification | notification resume: anObject ]! !

!PRCurrentContext class methodsFor: 'accessing' stamp: 'lr 9/24/2007 19:14'!
value
	"This is the read accessor of the current context."

	^ self raiseSignal ifNotNilDo: [ :result | result context ]! !

!PRCurrentContext class methodsFor: 'accessing' stamp: 'lr 9/24/2007 19:14'!
value: aContext
	"This is the write accessor of the current context."

	self raiseSignal context: aContext! !

!MAVisitor methodsFor: '*pier-model-accessing' stamp: 'lr 3/9/2006 11:29'!
context
	^ PRCurrentContext value! !

!MAVisitor methodsFor: '*pier-model-accessing' stamp: 'lr 3/9/2006 11:29'!
context: aContext
	PRCurrentContext value: aContext! !

!MAVisitor methodsFor: '*pier-model-visiting-description' stamp: 'lr 10/17/2007 23:02'!
visitDocumentDescription: anObject
	self visitMemoDescription: anObject! !

!MAVisitor methodsFor: '*pier-model-visiting-description' stamp: 'lr 10/16/2007 20:03'!
visitStructureDescription: anObject
	self visitElementDescription: anObject! !

MACompatibility subclass: #PRCompatibility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Core'!

!PRCompatibility class methodsFor: 'environment' stamp: 'lr 3/9/2006 11:30'!
hashPassword: aString
	"Answer a secure-hash value to be used to store and compare passwords in a save way."

	^ SecureHashAlgorithm new hashMessage: aString! !

!MAStringReader methodsFor: '*pier-model-visiting' stamp: 'lr 10/16/2007 20:12'!
visitDocumentDescription: aDescription
	self object: (aDescription parserClass
		parseStream: self stream)! !

!MAStringReader methodsFor: '*pier-model-visiting' stamp: 'lr 11/2/2007 15:16'!
visitStructureDescription: aDescription
	self object: (PRPathLookup
		start: self context structure path: self contents
		onError: [ self error: 'Invalid path' ])! !

!MADescription methodsFor: '*pier-model' stamp: 'lr 5/24/2006 15:15'!
beEditable
	self propertyAt: #editable put: true! !

!MADescription methodsFor: '*pier-model' stamp: 'lr 12/15/2006 12:08'!
beSearchable
	self propertyAt: #searchable put: true! !

!MADescription methodsFor: '*pier-model' stamp: 'lr 5/24/2006 15:15'!
isEditable
	^ self propertyAt: #editable ifAbsent: [ false ]! !

!MADescription methodsFor: '*pier-model' stamp: 'lr 12/15/2006 12:08'!
isSearchable
	^ self propertyAt: #searchable ifAbsent: [ false ]! !

!Collection methodsFor: '*pier-model' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitAll: self! !

!DateAndTime methodsFor: '*pier-model' stamp: 'lr 5/28/2007 16:31'!
asSortableString
	"A small interpreter to get a date exactly the way required."

	| code |
	code := #( year 4 $- monthIndex 2 $- dayOfMonth 2 $ hour 2 $- minute 2 $- second 2 ) readStream.
	^ String streamContents: [ :stream |
		[ code atEnd ] whileFalse: [
			stream nextPutAll: ((self perform: code next)
				printPaddedWith: $0 to: code next).
			code next
				ifNotNilDo: [ :separator | stream nextPut: separator ] ] ]! !

MAElementDescription subclass: #PRStructureDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Magritte'!

!PRStructureDescription class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRStructureDescription class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'Structure'! !

!PRStructureDescription methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
acceptMagritte: aVisitor
	aVisitor visitStructureDescription: self! !

!PRStructureDescription methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
kind
	^ PRStructure! !

MAMemoDescription subclass: #PRDocumentDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Magritte'!

!PRDocumentDescription class methodsFor: 'accessing' stamp: 'lr 10/17/2007 22:59'!
label
	^ 'Document'! !

!PRDocumentDescription methodsFor: 'visiting' stamp: 'lr 10/16/2007 20:02'!
acceptMagritte: aVisitor
	aVisitor visitDocumentDescription: self! !

!PRDocumentDescription methodsFor: 'accessing' stamp: 'lr 10/16/2007 20:00'!
kind
	^ PRDocument! !

!PRDocumentDescription methodsFor: 'accessing' stamp: 'lr 10/16/2007 20:10'!
parserClass
	"Answer the default document parser for the receiver."

	^ PRDocumentParser! !

!PRDocumentDescription methodsFor: 'accessing' stamp: 'lr 10/16/2007 20:10'!
writerClass
	"Answer the default document writer for the receiver."

	^ PRWikiWriter! !

!Object methodsFor: '*pier-model' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	self subclassResponsibility! !

!Object methodsFor: '*pier-model' stamp: 'lr 3/9/2006 11:29'!
acceptDecorated: aVisitor
	self accept: aVisitor! !

Object subclass: #PRDocumentParser
	instanceVariableNames: 'stream items textMatcher lineMatcher'
	classVariableNames: 'CharacterLf CharacterCr'
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDocumentParser class methodsFor: 'private' stamp: 'lr 12/30/2007 22:34'!
buildLineMatcher
	| result |
	result := Dictionary new.
	result
		at: PRAnchor markup put: PRAnchor;
		at: PRHorizontalRule markup put: PRHorizontalRule;
		at: PRHeader markup put: PRHeader;
		at: PRDataItem markup put: PRList;
		at: PRTermItem markup put: PRList;
		at: PRUnorderedList markup put: PRList;
		at: PROrderedList markup put: PRList;
		at: PRTableCell markup put: PRTable;
		at: PRPreformatted markup put: PRPreformatted.
	^ result! !

!PRDocumentParser class methodsFor: 'private' stamp: 'lr 4/24/2007 21:25'!
buildTextMatcher
	| result |
	result := Dictionary new.
	result
		at: '*' put: PRLink;
		at: '+' put: PRLink.
	PRFormat allSubclassesDo: [ :each |
		result
			at: each markup
			put: each ].
	^ result! !

!PRDocumentParser class methodsFor: 'escaping' stamp: 'lr 4/5/2007 14:04'!
escape: aString
	^ self textMatcher keys
		inject: (self escape: aString using: '\')
		into: [ :result :each | self escape: result using: each ]! !

!PRDocumentParser class methodsFor: 'escaping' stamp: 'lr 4/5/2007 14:04'!
escape: aString using: aSearchString
	| string index |
	string := aString.
	index := string findString: aSearchString.
	[ index > 0 ] whileTrue: [
		string := (string first: index - 1) , '\' , (string allButFirst: index - 1).
		index := string findString: aSearchString startingAt: index + aSearchString size + 1 ].
	^ string! !

!PRDocumentParser class methodsFor: 'initialization' stamp: 'lr 12/30/2007 21:46'!
initialize
	CharacterCr := Character cr.
	CharacterLf := Character lf
	! !

!PRDocumentParser class methodsFor: 'accessing' stamp: 'lr 12/30/2007 22:34'!
lineMatcher
	^ LineMatcher ifNil: [ LineMatcher := self buildLineMatcher ]! !

!PRDocumentParser class methodsFor: 'accessing' stamp: 'lr 4/24/2007 21:08'!
lineMatcherDefault
	^ LineMatcherDefault ifNil: [ LineMatcherDefault := PRParagraph ]! !

!PRDocumentParser class methodsFor: 'parsing' stamp: 'lr 4/4/2007 14:59'!
on: aStream
	^ self basicNew initializeOn: aStream! !

!PRDocumentParser class methodsFor: 'parsing' stamp: 'lr 4/4/2007 14:58'!
parse: aString
	^ self parseStream: aString readStream! !

!PRDocumentParser class methodsFor: 'parsing' stamp: 'lr 4/4/2007 14:58'!
parseStream: aStream
	^ (self on: aStream) parse! !

!PRDocumentParser class methodsFor: 'accessing' stamp: 'lr 4/24/2007 21:08'!
textMatcher
	^ TextMatcher ifNil: [ TextMatcher := self buildTextMatcher ]! !

!PRDocumentParser class methodsFor: 'escaping' stamp: 'lr 4/5/2007 12:03'!
unescape: aString
	| input output |
	input := aString readStream.
	output := (String new: aString size) writeStream.
	[ input atEnd ] whileFalse: [
		output nextPutAll: (input upTo: $\).
		input atEnd
			ifFalse: [ output nextPut: input next ] ].
	^ output contents! !

!PRDocumentParser methodsFor: 'adding' stamp: 'lr 4/24/2007 20:34'!
add: aDocumentItem
	^ items addLast: aDocumentItem! !

!PRDocumentParser methodsFor: 'adding' stamp: 'lr 12/30/2007 19:24'!
addListItem: aListItem ofType: aTypeCollection
	^ self addListItem: aListItem to: items ofType: aTypeCollection! !

!PRDocumentParser methodsFor: 'adding' stamp: 'lr 12/30/2007 19:25'!
addListItem: aListItem to: aCollection ofType: aTypeCollection
	| list type |
	type := aTypeCollection isEmpty
		ifFalse: [ aTypeCollection first ].
	(aCollection isEmpty or: [ aCollection last class ~= type ])
		ifTrue: [ aCollection add: (type with: aListItem) ]
		ifFalse: [
			list := aCollection last.
			aTypeCollection size > 1
				ifFalse: [ list add: aListItem ]
				ifTrue: [
					| newChildren listItem |
					listItem := list children last.
					newChildren := listItem children asOrderedCollection.
					self 
						addListItem: aListItem to: newChildren
						ofType: aTypeCollection allButFirst.
					newChildren size = listItem children size
						ifFalse: [ listItem add: newChildren last ] ] ]! !

!PRDocumentParser methodsFor: 'adding' stamp: 'lr 12/20/2007 14:37'!
addParagraph: aParagraph
	aParagraph children isEmpty
		ifTrue: [ items add: PREmptyParagraph new ]
		ifFalse: [
			(items isEmpty or: [ self lastDocumentItem class ~= aParagraph class ])
				ifTrue: [ items add: aParagraph ]
				ifFalse: [
					items last
						add: PRLineBreak new;
						addAll: aParagraph children ] ].
	^ items last! !

!PRDocumentParser methodsFor: 'adding' stamp: 'lr 4/24/2007 20:35'!
combine: aClass with: aDocumentItem
	^ self lastDocumentItem class = aClass
		ifTrue: [ items last add: aDocumentItem ]
		ifFalse: [ items addLast: (aClass with: aDocumentItem) ]! !

!PRDocumentParser methodsFor: 'private' stamp: 'lr 4/6/2007 22:08'!
findFirst: aSearchString at: anInteger in: aString
	"Find the first unescaped occurence of aSearchString starting at anInteger in aString."

	| index |
	index := aString findString: aSearchString startingAt: anInteger.
	[ anInteger < index and: [ (aString at: index - 1 ifAbsent: nil) = $\ ] ]
		whileTrue: [ index := aString findString: aSearchString startingAt: index + 1 ].
	^ index! !

!PRDocumentParser methodsFor: 'private' stamp: 'lr 4/6/2007 22:11'!
findFirstOf: anArray at: anInteger in: aString
	"Find the first unescaped occurence of any of the search strings in anArray starting at anInteger in aString. Answer the search string or nil if not found."

	| index minIndex minMarkup |
	minIndex := aString size. minMarkup := nil.
	anArray do: [ :each |
		index := self findFirst: each at: anInteger in: aString.
		(0 < index and: [ index < minIndex ])
			ifTrue: [ minIndex := index. minMarkup := each ] ].
	^ minMarkup! !

!PRDocumentParser methodsFor: 'initialization' stamp: 'lr 9/24/2007 19:20'!
initializeOn: aStream
	stream := aStream.
	textMatcher := self class textMatcher keys asArray
		sort: [ :a :b | a size > b size ];
		yourself.
	lineMatcher := self class lineMatcher keys asArray
		sort: [ :a :b | a size > b size ];
		yourself! !

!PRDocumentParser methodsFor: 'accessing' stamp: 'lr 4/4/2007 15:24'!
lastDocumentItem
	^ items isEmpty ifFalse: [ items last ]! !

!PRDocumentParser methodsFor: 'accessing' stamp: 'lr 4/12/2007 14:04'!
lineMatcher
	^ lineMatcher! !

!PRDocumentParser methodsFor: 'private' stamp: 'lr 12/20/2007 13:22'!
nextLine
	"Answer the next line. This method implements a state machine to properly detect line endings (cr, cr lf, or lf) as encountered from different sources."

	| output next |
	stream atEnd ifTrue: [ ^ nil ].
	output := WriteStream on: (String new: 100).
	[ stream atEnd ] whileFalse: [
		next := stream next.
		next == CharacterLf
			ifTrue: [ ^ output contents ].
		next == CharacterCr ifTrue: [
			stream peek == CharacterLf
				ifTrue: [ stream next ].
			^ output contents ].
		output nextPut: next ].
	^ output contents! !

!PRDocumentParser methodsFor: 'parsing' stamp: 'lr 12/20/2007 11:56'!
parse
	items := OrderedCollection new.
	[ stream atEnd ]
		whileFalse: [ self parseLine: self nextLine ].
	^ PRDocument withAll: items! !

!PRDocumentParser methodsFor: 'parsing' stamp: 'lr 5/28/2007 16:31'!
parseLine: aString
	"Parses ==aString==, that represents a single line of input, to a *PRDocumentItem* and add it to the ==items== collection."

	self lineMatcher do: [ :string |
		(aString beginsWith: string) ifTrue: [
			^ (self class lineMatcher at: string)
				parse: aString with: self ] ].
	self class lineMatcherDefault
		parse: aString with: self! !

!PRDocumentParser methodsFor: 'parsing' stamp: 'lr 4/5/2007 16:02'!
parseString: aString
	| string |
	string := self class unescape: aString.
	string isEmpty ifTrue: [ ^ #() ].
	^ Array with: (PRText content: string)! !

!PRDocumentParser methodsFor: 'parsing' stamp: 'lr 4/24/2007 21:05'!
parseText: aString
	"Parses ==aString== and answer a collection of *PRText*, *PRFormat* and *PRLink* instances. Take care not to take into account any markup item that is escaped. This implementation is a bit slow, but who cares, it happens only once."

	| markup start stop result |
	markup := self findFirstOf: self textMatcher at: 1 in: aString.
	markup isNil ifFalse: [
		start := self findFirst: markup at: 1 in: aString.
		stop := self findFirst: markup at: start + markup size in: aString.
		start < stop ifTrue: [
			result := Array new writeStream.
			result nextPutAll: (self parseString: (aString first: start - 1)).
			result nextPut: ((self class textMatcher at: markup)
				parse: (aString copyFrom: start to: stop + markup size - 1)
				with: self).
			result nextPutAll: (self parseText: (aString allButFirst: stop + markup size - 1)).
			^ result contents ] ].
	^ self parseString: aString! !

!PRDocumentParser methodsFor: 'accessing' stamp: 'lr 4/12/2007 14:04'!
textMatcher
	^ textMatcher! !

Object subclass: #PRMacroExpander
	instanceVariableNames: 'character table default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Utilities'!

PRMacroExpander class
	instanceVariableNames: 'Default'!

PRMacroExpander class
	instanceVariableNames: 'Default'!

!PRMacroExpander class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
default
	^ Default! !

!PRMacroExpander class methodsFor: 'class initialization' stamp: 'lr 1/29/2008 09:08'!
initialize
	Default := self on: (Dictionary new
		at: $c put: [ :char :context | context command label ];		" current command "
		at: $r put: [ :char :context | context kernel root title ];		" current root structure "
		at: $t put: [ :char :context | context structure title ];			" current structure "
		at: $k put: [ :char :context | context kernel name ];			" current kernel name "
		yourself)! !

!PRMacroExpander class methodsFor: 'instance creation' stamp: 'lr 1/26/2008 09:58'!
new
	^ self basicNew initialize! !

!PRMacroExpander class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
on: aDictionary
	^ self new
		table: aDictionary;
		yourself! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
character
	^ character! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
character: aCharacter
	character := aCharacter! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
default
	^ default! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
default: aBlock
	default := aBlock! !

!PRMacroExpander methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:29'!
defaultCharacter
	^ $%! !

!PRMacroExpander methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:29'!
defaultDefault
	^ [ :char |
		self character = char
			ifTrue: [ String with: self character ]
			ifFalse: [ String with: self character with: char ] ]! !

!PRMacroExpander methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:29'!
defaultTable
	^ Dictionary new! !

!PRMacroExpander methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
expand: aReadStream using: anArray
	^ String streamContents: [ :writeStream |
		[ aReadStream atEnd ] whileFalse: [
			writeStream nextPutAll: (aReadStream upTo: self character).
			aReadStream atEnd ifFalse: [
				self
					expand: aReadStream
					using: anArray
					to: writeStream ] ] ]! !

!PRMacroExpander methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
expand: aReadStream using: anArray to: aWriteStream
	| char block |
	block := self table
		at: (char := aReadStream next)
		ifAbsent: [ self default ].
	^ aWriteStream nextPutAll: (block
		valueWithPossibleArgs: (anArray
			copyWithFirst: char))! !

!PRMacroExpander methodsFor: 'initialization' stamp: 'lr 1/26/2008 09:58'!
initialize
	self table: self defaultTable.
	self character: self defaultCharacter.
	self default: self defaultDefault! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
table
	^ table! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
table: aDictionary
	table := aDictionary! !

!PRMacroExpander methodsFor: 'evaluation' stamp: 'lr 3/9/2006 11:29'!
value: aString
	^ self value: aString withArguments: Array new! !

!PRMacroExpander methodsFor: 'evaluation' stamp: 'lr 3/9/2006 11:29'!
value: aString value: anObject
	^ self value: aString withArguments: (Array with: anObject)! !

!PRMacroExpander methodsFor: 'evaluation' stamp: 'lr 11/3/2007 10:07'!
value: aString withArguments: anArray
	aString isEmptyOrNil ifTrue: [ ^ aString ].
	^ self expand: aString readStream using: anArray! !

Object subclass: #PRMigrations
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Utilities'!

!PRMigrations class methodsFor: 'initialization' stamp: 'lr 10/27/2007 12:28'!
initialize
	self migrateLinkParameters! !

!PRMigrations class methodsFor: 'migrations' stamp: 'lr 9/12/2007 18:18'!
migrateLinkParameters
	PRCompatibility allSubInstancesOf: PRLink do: [ :each |
		each parameters isNil
			ifTrue: [ each parameters: #() ] ]! !

Object subclass: #PRObject
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Core'!

!PRObject commentStamp: 'lr 5/28/2006 17:00' prior: 0!
I am the root of objects within Pier. I hold a dictionary of properties, so that users can easily annotate me with new values. I am visitable.!

PRObject subclass: #PRCommand
	instanceVariableNames: 'timestamp context answer checked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRCommand commentStamp: 'lr 4/10/2007 21:13' prior: 0!
I am an abstract superclass of the command pattern in Pier. All modifications to the model have to be done through subclasses of myself, else they do not get properly logged with the persistency mechanism. I hold the context in which the receiver is executed in the instance variable context. To modify the resulting context, create a copy of the current context and store it in the instance variable answer.

The following event-handlers are called when executing an action in the given order. Do override these messages to customize the command, never override the other internal methods:
- Override the message ==#doValidate== to check the valid setup of the command and to raise exceptions in case any precondition isn't met. Speak here or forever have your peace!! Don't change the model in there.
- Override the message ==#doExecute== to execute the actual command. Do not raise exceptions in there, catch all the problems in ==#doValidate==.
- Override the message ==#doPersistency== to save the command that has been just executed with the current persistency strategy. Most commands don't need to override this message and just stick with the default behavior.
- Override the message ==#doAnswer== to create the answer context. Most commands don't need to override this message and just stick with the default behavior.

Do not play with funny jumpy things, such as resumable exceptions or continuations, inside the code of the command hierarchy or you will very likely run into severe problems.!

PRCommand subclass: #PRAddCommand
	instanceVariableNames: 'name type link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRAddCommand commentStamp: '<historical>' prior: 0!
I'm a command used to add new structures to your structures. My code is very interesting if you want to understand how Pier is designed.

Type is the class (subclass of PRStructure) for which a new instance will be created.!

!PRAddCommand class methodsFor: 'accessing' stamp: 'lr 5/3/2006 16:58'!
accessKey
	^ $a! !

!PRAddCommand class methodsFor: 'accessing-description' stamp: 'lr 9/27/2007 10:21'!
descriptionName
	^ MAStringDescription new
		addCondition: [ :each | PRPath isValidName: each ]
			labelled: 'Invalid structure name';
		selectorAccessor: #name;
		label: 'Name';
		priority: 100;
		beRequired;
		yourself! !

!PRAddCommand class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 22:58'!
descriptionType
	^ MASingleOptionDescription new
		selectorAccessor: #type;
		label: 'Type';
		priority: 110;
		default: PRPage;
		options: [ self structureClasses ] asDynamicObject;
		reference: MAClassDescription new;
		beRequired;
		beSorted;
		yourself! !

!PRAddCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRAddCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'Add'! !

!PRAddCommand class methodsFor: 'private' stamp: 'lr 3/28/2007 11:07'!
structureClasses
	| context |
	context := PRCurrentContext value.
	^ PRStructure withAllConcreteClasses select: [ :each |
		(context structure class canBeParentOf: each)
			and: [ each canBeChildOf: context structure class ] ]! !

!PRAddCommand methodsFor: 'private' stamp: 'lr 9/6/2006 13:29'!
child
	"Create a new structure of the selected species, a subclass of PRStructure. Set the title if necessary, else it will be generated automatically."

	| child |
	child := self type named: self name.
	(self link notNil and: [ self link hasAlias ])
		ifTrue: [ child title: self link alias ].
	^ child! !

!PRAddCommand methodsFor: 'events' stamp: 'lr 9/27/2007 09:15'!
doExecute
	"Create a new structure of requested type and add it to the children list of the current structure. If possible the following context will be set to an editor or a view onto the new structure."

	| structure |
	super doExecute.
	self structure
		addChild: (structure := self child).
	self link isNil
		ifFalse: [ self link target: structure; update ].
	self answer: (self context
		structure: structure
		command: (structure editCommandClass notNil
			ifTrue: [ structure editCommandClass ]
			ifFalse: [ structure viewCommandClass ])
				new)! !

!PRAddCommand methodsFor: 'events' stamp: 'lr 1/29/2007 15:10'!
doValidate
	"Verify that the new structure can be added before launching #doExecute. Basically, the name must be unique."

	super doValidate.
	self validateChild: self child in: self structure! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 9/6/2006 13:14'!
link
	^ link! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 9/6/2006 13:14'!
link: aLink
	link := aLink! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
name
	^ name ifNil: [ name := self uniqueName: 'untitled' in: self structure ]! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
name: aString
	name := aString! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
type
	^ type ifNil: [ type := PRPage ]! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
type: aClass
	type := aClass! !

PRCommand subclass: #PRChangeCommand
	instanceVariableNames: 'fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRChangeCommand commentStamp: 'lr 11/5/2007 21:34' prior: 0!
Abstract command to edit structures.!

!PRChangeCommand methodsFor: 'events' stamp: 'lr 11/6/2007 08:17'!
doExecute
	super doExecute.
	self fields keysAndValuesDo: [ :desc :value | self target write: value using: desc ]! !

!PRChangeCommand methodsFor: 'accessing' stamp: 'lr 11/6/2007 08:17'!
fields
	"Answer a dictionary mapping descriptions to their respecive data fields."
	
	^ fields ifNil: [ fields := Dictionary new ]! !

!PRChangeCommand methodsFor: 'copying' stamp: 'lr 11/20/2007 16:23'!
postCopy
	super postCopy.
	fields := fields copy! !

!PRChangeCommand methodsFor: 'private' stamp: 'lr 11/5/2007 21:53'!
readUsing: aDescription
	^ self fields at: aDescription ifAbsent: [ self target readUsing: aDescription ]! !

!PRChangeCommand methodsFor: 'accessing' stamp: 'lr 11/5/2007 21:53'!
target
	"The target where this edit operation is applied to."

	^ self structure! !

!PRChangeCommand methodsFor: 'private' stamp: 'lr 11/5/2007 21:38'!
write: anObject using: aDescription
	self fields at: aDescription put: anObject! !

PRChangeCommand subclass: #PREditCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PREditCommand commentStamp: 'lr 11/5/2007 21:40' prior: 0!
Command to edit a structure, e.g. all the descriptions that are tagged as ==#beEditable==.!

!PREditCommand class methodsFor: 'accessing' stamp: 'lr 5/3/2006 16:58'!
accessKey
	^ $e! !

!PREditCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PREditCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'Edit'! !

!PREditCommand methodsFor: 'accessing' stamp: 'lr 5/24/2006 15:16'!
description
	^ self structure description select: [ :each | each isEditable ]! !

!PREditCommand methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isEdit
	^ true! !

!PRCommand class methodsFor: 'accessing' stamp: 'lr 5/3/2006 16:57'!
accessKey
	^ nil! !

!PRCommand class methodsFor: 'instance-creation' stamp: 'lr 1/29/2008 09:04'!
context: aContext
	(self isValidIn: aContext)
		ifFalse: [ self error: self label , ' is not useable in the given context.' ].
	^ self new
		setContext: aContext;
		yourself! !

!PRCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isValidIn: aContext
	"Verify that a command as a meaning for the context aContext. Override this command to add new constraints that are static to the command."

	^ aContext structure isValidCommand: self in: aContext! !

!PRCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
shortLabel
	^ self label! !

!PRCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
structureClass
	^ PRStructure! !

!PRCommand methodsFor: 'accessing' stamp: 'lr 10/22/2007 22:12'!
answer
	"Return a new context that should be activated after executing this action. Since the answer might get modified afterwards, this should always be a copy."

	^ answer copy! !

!PRCommand methodsFor: 'accessing' stamp: 'lr 10/22/2007 22:12'!
answer: aContext
	"Set the resulting context of this command."

	answer := aContext! !

!PRCommand methodsFor: 'toggling' stamp: 'lr 2/12/2007 19:07'!
beChecked
	"Enable checks when executing the receiver. This is the default."

	checked := true! !

!PRCommand methodsFor: 'toggling' stamp: 'lr 2/12/2007 19:07'!
beUnchecked
	"Disable checks when executing the receiver. Do this only in a trused environemnt and if you are absolutely sure that the execution will cause no conflicts."

	checked := false! !

!PRCommand methodsFor: 'accessing-readonly' stamp: 'lr 3/9/2006 11:29'!
context
	"Return the current context of the receiver."

	^ context! !

!PRCommand methodsFor: 'events' stamp: 'lr 4/13/2007 14:45'!
doAnswer
	"Override this message to create the answer context. Most commands don't need to override this message and just stick with the default behavior."

	self answer ifNil: [ self answer: (self context structure: self structure) ]! !

!PRCommand methodsFor: 'events' stamp: 'lr 4/10/2007 21:44'!
doExecute
	"Override this message to execute the actual command. Do not raise exceptions in there, catch all the problems in ==#doValidate==."! !

!PRCommand methodsFor: 'events' stamp: 'lr 9/11/2006 10:54'!
doValidate
	"Override this message to check the valid setup of the command and to raise exceptions in case any precondition isn't met. Speak here or forever have your peace!! Don't change the model in there."

	self structure validateCommand: self! !

!PRCommand methodsFor: 'actions' stamp: 'lr 4/10/2007 21:44'!
execute
	"Execute the command of the receiver. To implement your action in the code of one of my subclasses. Never override this message, but instead have a look at the different template methods (==#doValidate==, ==#doExecute==, ==#doAnswer==) available in the events protocol."

	self assert: self context command == self.
	self isView
		ifTrue: [ self shouldNotImplement ].
	self timestamp: TimeStamp now.
	self kernel persistency
		execute: self.
	self doAnswer! !

!PRCommand methodsFor: 'testing' stamp: 'lr 4/10/2007 21:44'!
isChecked
	"Answer ==true== if the command should be checked before execution, e.g. the method ==#doValidate== should be executed at all."

	^ checked ifNil: [ checked := true ]! !

!PRCommand methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isEdit
	^ false! !

!PRCommand methodsFor: 'testing' stamp: 'lr 5/27/2006 17:26'!
isLogged
	"Most commands are logged. This means they do modify the model and are therefore preserved in the history. However there are some that just display something or change the state of the current context and neither change the model nor need to be logged."

	^ true! !

!PRCommand methodsFor: 'testing' stamp: 'lr 5/27/2006 17:26'!
isQuick
	"Quick commands do not have a configuration interface (probably not even Magritte descriptions) and therefore should not be presented to the user but simply executed."

	^ false! !

!PRCommand methodsFor: 'testing' stamp: 'lr 4/10/2007 21:44'!
isView
	"Most commands are not a view. This means they override ==#doExecute== to do something meaningful on the context or the model."

	^ false! !

!PRCommand methodsFor: 'accessing-readonly' stamp: 'lr 5/28/2006 21:10'!
kernel
	"Answer the kernel the receiver is working on."

	^ self context kernel! !

!PRCommand methodsFor: 'accessing-readonly' stamp: 'lr 1/29/2008 09:01'!
label
	^ self class label! !

!PRCommand methodsFor: 'accessing-readonly' stamp: 'lr 3/9/2006 11:29'!
root
	^ self context kernel root! !

!PRCommand methodsFor: 'initialization' stamp: 'lr 1/17/2007 11:30'!
setContext: aContext
	context := aContext! !

!PRCommand methodsFor: 'accessing-readonly' stamp: 'rjl 5/11/2006 22:36'!
structure
	^ self context structure! !

!PRCommand methodsFor: 'accessing' stamp: 'lr 1/17/2007 11:30'!
timestamp
	^ timestamp! !

!PRCommand methodsFor: 'accessing' stamp: 'lr 1/17/2007 11:34'!
timestamp: aTimeStamp
	timestamp := aTimeStamp! !

!PRCommand methodsFor: 'private' stamp: 'lr 9/25/2006 08:05'!
uniqueName: aString in: aStructure
	"Answer an unique structure name with the prefix aString within the parent aStructure."

	| index name |
	(aStructure isNil or: [ aStructure hasChildren not ])
		ifTrue: [ ^ aString ].
	(aStructure childrenDecoration includes: aString)
		ifFalse: [ ^ aString ].
	index := 1.
	[ aStructure childrenDecoration
		includes: (name := aString , ' ' , (index := index + 1) asString) ]
		whileTrue.
	^ name! !

!PRCommand methodsFor: 'validating' stamp: 'lr 4/10/2007 21:45'!
validateChild: aChildStructure in: aStructure
	"Make sure that ==aChildStructure== can be added as child or replace an existing child in a ==aStructure==."

	self validateChild: aChildStructure named: aChildStructure name in: aStructure! !

!PRCommand methodsFor: 'validating' stamp: 'lr 3/9/2006 11:29'!
validateChild: aChildStructure named: aString in: aStructure
	self validateName: aString of: aChildStructure in: aStructure.
	self validateNestingOf: aChildStructure in: aStructure! !

!PRCommand methodsFor: 'validating' stamp: 'lr 4/10/2007 21:45'!
validateName: aString of: aChildStructure in: aStructure
	"Make sure that ==aChildStructure== with the title ==aString== can be added as child or replace an existing child in a ==aStructure==."

	| child |
	(aStructure isNil or: [ aStructure hasChildren not ])
		ifTrue: [ ^ self ].
	child := aStructure childrenDecoration
		at: aString
		ifAbsent: [ ^ self ].
	child ~= aChildStructure
		ifTrue: [ PRConflictingNameError description: self description signal: aString printString , ' conflicts in ' , aStructure title printString ]! !

!PRCommand methodsFor: 'validating' stamp: 'lr 5/28/2007 16:31'!
validateNestingOf: aChildStructure in: aStructure
	"Make sure that ==aChildStructure== can be added as child to ==aStructure== and that ==aStructure== can have ==aChildStructure== as a child."

	aStructure isNil
		ifTrue: [ ^ self ].
	((aStructure canBeParentOf: aChildStructure)
		and: [ aChildStructure canBeChildOf: aStructure ])
			ifTrue: [ ^ self ].
	PRInvalidNestingError
		description: self description
		signal: aChildStructure title printString , ' can not be a child of ' , aStructure title printString! !

PRCommand subclass: #PRLocationCommand
	instanceVariableNames: 'name target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRLocationCommand commentStamp: 'lr 11/5/2007 21:36' prior: 0!
Abstract command to copy or move a structure.!

PRLocationCommand subclass: #PRCopyCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRCopyCommand commentStamp: 'lr 11/5/2007 21:35' prior: 0!
Command to copy a structure.!

!PRCopyCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRCopyCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'Copy'! !

!PRCopyCommand methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:29'!
defaultName
	^ self uniqueName: self structure name , ' copy' in: self target! !

!PRCopyCommand methodsFor: 'events' stamp: 'lr 2/12/2007 19:07'!
doExecute
	| structure |
	super doExecute.
	self target childrenDecoration
		add: (structure := self structure copy
			name: self name;
			title: nil;
			yourself).
	structure incomingReferences
		toAll: (structure enumerator
			everything contents);
		do: [ :each | each update ].
	self answer: (self context
		structure: structure)! !

!PRLocationCommand class methodsFor: 'accessing-description' stamp: 'lr 9/27/2007 10:21'!
descriptionName
	^ MAStringDescription new
		addCondition: [ :each | PRPath isValidName: each ]
			labelled: 'Invalid structure name';
		selectorAccessor: #name;
		label: 'Name';
		priority: 110;
		beRequired;
		yourself! !

!PRLocationCommand class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 23:05'!
descriptionTarget
	^ PRStructureDescription new
		selectorAccessor: #target;
		label: 'Target';
		priority: 100;
		beRequired;
		yourself! !

!PRLocationCommand methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:29'!
defaultName
	^ self structure name! !

!PRLocationCommand methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:29'!
defaultTarget
	^ self structure parent! !

!PRLocationCommand methodsFor: 'events' stamp: 'lr 3/9/2006 11:29'!
doValidate
	super doValidate.
	self validateChild: self structure named: self name in: self target! !

!PRLocationCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
name
	^ name ifNil: [ name := self defaultName ]! !

!PRLocationCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
name: aString
	name := aString! !

!PRLocationCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
target
	^ target ifNil: [ target := self defaultTarget ]! !

!PRLocationCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
target: aStructure
	target := aStructure! !

PRLocationCommand subclass: #PRMoveCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRMoveCommand commentStamp: 'lr 11/5/2007 21:35' prior: 0!
Command to move a structure.!

!PRMoveCommand class methodsFor: 'accessing' stamp: 'lr 5/3/2006 16:58'!
accessKey
	^ $m! !

!PRMoveCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRMoveCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isValidIn: aContext
	^ (super isValidIn: aContext)
		and: [ aContext structure isRoot not ]! !

!PRMoveCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'Move'! !

!PRMoveCommand methodsFor: 'events' stamp: 'lr 2/12/2007 19:07'!
doExecute
	super doExecute.
	self structure name: self name.
	self target
		addChild: self structure remove.
	self root incomingReferences
		toAll: (self structure enumerator
			everything contents);
		do: [ :each | each update ]! !

!PRMoveCommand methodsFor: 'events' stamp: 'lr 2/12/2007 19:07'!
doValidate
	super doValidate.
	(self structure isAncestorOf: self target)
		ifFalse: [ ^ self ].
	PRInvalidNestingError
		description: self description
		signal: self structure title printString , ' can not be moved into itself'! !

PRCommand subclass: #PRRemoveCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRRemoveCommand commentStamp: 'lr 11/5/2007 21:35' prior: 0!
Command to remove a structure.!

!PRRemoveCommand class methodsFor: 'accessing' stamp: 'lr 5/3/2006 16:58'!
accessKey
	^ $r! !

!PRRemoveCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRRemoveCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isValidIn: aContext
	^ (super isValidIn: aContext)
		and: [ aContext structure isRoot not ]! !

!PRRemoveCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'Remove'! !

!PRRemoveCommand methodsFor: 'events' stamp: 'lr 3/28/2007 10:30'!
doExecute
	| parent |
	super doExecute.
	self root incomingReferences
		toAll: (self structure enumerator
			everything contents);
		do: [ :each | each target: nil ].
	parent := self structure parent.
	self structure remove.
	self answer: (self context
		structure: parent)! !

!PRRemoveCommand methodsFor: 'events' stamp: 'lr 3/5/2007 14:07'!
doValidate
	super doValidate.
	self structure isRoot
		ifFalse: [ ^ self ].
	(PRStructureError structure: self structure)
		signal: 'Unable to remove root node.'! !

!PRRemoveCommand methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isQuick
	^ true! !

PRCommand subclass: #PRViewCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRViewCommand commentStamp: 'lr 11/5/2007 21:35' prior: 0!
Command (so called) to view a structure.!

!PRViewCommand class methodsFor: 'accessing' stamp: 'lr 5/3/2006 16:58'!
accessKey
	^ $v! !

!PRViewCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRViewCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'View'! !

!PRViewCommand methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isLogged
	^ false! !

!PRViewCommand methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isView
	^ true! !

PRObject subclass: #PRContext
	instanceVariableNames: 'kernel structure command enumerator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Kernel'!

!PRContext commentStamp: 'lr 6/1/2006 21:12' prior: 0!
I am the context in which a user is browsing the system. I hold all the information any part of Pier might be interested in: the currently used kernel, the structure that is currently displayed, the command that is being executed and the user currently logged in.

I am an immutable object. Users should never try to modify me. Instead use the modification methods that return a copy of myself.!

!PRContext class methodsFor: 'accessing-description' stamp: 'lr 1/29/2008 09:02'!
descriptionCommand
	^ MAStringDescription new
		chainAccessor: #( command label );
		label: 'Command';
		beReadonly;
		yourself! !

!PRContext class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 17:38'!
descriptionStructure
	^ PRStructureDescription new
		accessor: (MASelectorAccessor read: #structure write: #setStructure:);
		label: 'Structure';
		yourself! !

!PRContext class methodsFor: 'accessing-description' stamp: 'tg 11/20/2007 16:36'!
descriptionTimestamp
	^ MATimeStampDescription new
		chainAccessor: #( command timestamp );
		label: 'Timestamp';
		beReadonly;
		yourself! !

!PRContext class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRContext class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
kernel: aKernel
	^ self kernel: aKernel structure: aKernel root! !

!PRContext class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
kernel: aKernel structure: aStructure
	^ self kernel: aKernel structure: aStructure command: aStructure viewCommandClass new! !

!PRContext class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
kernel: aKernel structure: aStructure command: aCommand
	^ self new
		setKernel: aKernel;
		setStructure: aStructure;
		setCommand: aCommand;
		yourself! !

!PRContext methodsFor: 'accessing' stamp: 'lr 4/10/2006 15:02'!
command
	"Answer the active command of this context."

	^ command! !

!PRContext methodsFor: 'navigation' stamp: 'lr 4/10/2007 21:46'!
command: aCommand
	"Create a copy of the current context with the current command replaced by ==aCommand==."

	^ self copy
		setCommand: aCommand;
		yourself! !

!PRContext methodsFor: 'accessing-conveniance' stamp: 'lr 5/27/2006 17:28'!
commands
	"Answer a list of possible commands, dispatching through the command class."

	^ PRCommand withAllConcreteClasses
		select: [ :each | each isValidIn: self ]! !

!PRContext methodsFor: 'enumerating' stamp: 'lr 1/21/2007 10:47'!
enumerator
	"Answer a copy of the current enumerator in the current context."

	^ self enumeratorFor: self structure! !

!PRContext methodsFor: 'enumerating' stamp: 'lr 4/10/2007 21:46'!
enumeratorFor: aStructure
	"Answer a copy of the current enumerator on ==aStructure==."

	^ enumerator copy structure: aStructure! !

!PRContext methodsFor: 'testing' stamp: 'lr 4/10/2007 21:46'!
isValid
	"Answer ==true== if the receiver is a valid context."

	^ self isValidCommand: self command class! !

!PRContext methodsFor: 'testing' stamp: 'lr 4/10/2007 21:46'!
isValidCommand: aCommandClass
	"Answer ==true== if the receiver is a valid context with the current command replaced by ==aCommandClass==."

	^ aCommandClass isValidIn: self! !

!PRContext methodsFor: 'accessing' stamp: 'lr 4/10/2006 15:01'!
kernel
	"Answer the underlying kernel of this context."

	^ kernel! !

!PRContext methodsFor: 'copying' stamp: 'lr 8/14/2007 23:51'!
postCopy
	super postCopy.
	self setCommand: command copy! !

!PRContext methodsFor: 'printing' stamp: 'lr 3/9/2006 11:29'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' stucture: '; print: self structure title.
	aStream nextPutAll: ' command: '; print: self command class label! !

!PRContext methodsFor: 'accessing-conveniance' stamp: 'lr 3/9/2006 11:29'!
root
	"Answer the current root node of the structure-tree."

	^ self kernel root! !

!PRContext methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setCommand: aCommand
	command := aCommand.
	command setContext: self! !

!PRContext methodsFor: 'initialization' stamp: 'lr 4/10/2006 15:00'!
setEnumerator: aVisitor
	enumerator := aVisitor! !

!PRContext methodsFor: 'initialization' stamp: 'lr 1/21/2007 10:39'!
setKernel: aKernel
	kernel := aKernel.
	self setEnumerator: PRChildrenVisitor new! !

!PRContext methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setStructure: aStructure
	structure := aStructure! !

!PRContext methodsFor: 'accessing' stamp: 'lr 4/10/2006 15:02'!
structure
	"Answer the currently browsed structure of this context."

	^ structure! !

!PRContext methodsFor: 'navigation' stamp: 'lr 4/10/2007 21:46'!
structure: aStructure
	"Create a copy of the current context with the current structure replaced by ==aStructure== and the current command replaced by the default view."

	^ self structure: aStructure command: aStructure viewCommandClass new! !

!PRContext methodsFor: 'navigation' stamp: 'lr 4/10/2007 21:47'!
structure: aStructure command: aCommand
	"Create a copy of the current context with the current structure replaced by ==aStructure== and the current command by ==aCommand==."

	^ self copy
		setStructure: aStructure;
		setCommand: aCommand;
		yourself! !

PRObject subclass: #PRDecorated
	instanceVariableNames: 'decorations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRDecorated commentStamp: 'lr 5/28/2006 17:43' prior: 0!
I am an abstract decorated object. My decorations are subclasses of *PRDecoration*. I provide all the tools to add, remove, query and visit my decorations.!

!PRDecorated methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
acceptDecorated: aVisitor
	self
		decorationsDo: [ :each | aVisitor visit: each ]
		ownerDo: [ :each | super acceptDecorated: aVisitor ]! !

!PRDecorated methodsFor: 'adding' stamp: 'lr 4/10/2007 21:47'!
addDecoration: aDecoration
	"Add ==aDecoration== to the receiver. This message ensures that ==aDecoration== is only added once and that the decorations remain properly sorted."

	^ self
		addDecoration: aDecoration
		ifPresent: [ :value | PRDecorationError signal: 'Decoration is already part of receiver.' ]! !

!PRDecorated methodsFor: 'adding' stamp: 'lr 9/27/2007 10:39'!
addDecoration: aDecoration ifPresent: aBlock
	"Add ==aDecoration== to the receiver. This message ensures that the decorations remain properly sorted and that there are no duplicates. In case ==aDecoration== is already within the receiver, the existing decoration is passed into ==aBlock==."

	| decoration |
	decoration := self decorations
		detect: [ :each | aDecoration = each ]
		ifNone: [ nil ].
	^ decoration isNil
		ifFalse: [ aBlock value: decoration ]
		ifTrue: [
			self setDecorations: ((decorations
				copyWith: (aDecoration
					setDecorated: self;
					yourself)) sort; yourself).
			aDecoration ]! !

!PRDecorated methodsFor: 'querying' stamp: 'lr 4/10/2007 21:47'!
decorationOfClass: aClass
	"Answer the first decoration of ==aClass==, raise an error if none could be found."

	^ self
		decorationOfClass: aClass
		ifAbsent: [ PRDecorationError signal: 'Decoration not found.' ]! !

!PRDecorated methodsFor: 'querying' stamp: 'lr 4/10/2007 21:47'!
decorationOfClass: aClass ifAbsent: aBlock
	"Answer the first decoration of ==aClass==, evaluate ==aBlock== if none could be found."

	^ self decorations
		detect: [ :each | aClass = each species ]
		ifNone: aBlock! !

!PRDecorated methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:37'!
decorations
	"Answer the sorted decorations of the receiver."

	^ decorations! !

!PRDecorated methodsFor: 'enumerating' stamp: 'lr 4/10/2007 21:47'!
decorationsDo: aBlock
	"Evaluate ==aBlock== in the right order with each of the receiver's decorations as the argument."

	self decorations do: aBlock! !

!PRDecorated methodsFor: 'enumerating' stamp: 'lr 4/10/2007 21:48'!
decorationsDo: aBlock ownerDo: anOwnerBlock
	"Evaluate ==aBlock== and ==anOwnerBlock== in the right order with each of the receiver's decorations and the receiver as the argument."

	self decorations do: [ :each |
		each priority negative
			ifTrue: [ aBlock value: each ] ].
	anOwnerBlock value: self.
	self decorations do: [ :each |
		each priority positive
			ifTrue: [ aBlock value: each ] ]! !

!PRDecorated methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
initialize
	super initialize.
	self setDecorations: #()! !

!PRDecorated methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopy
	super postCopy.
	self setDecorations: (self decorations collect: [ :each |
		each copy postCopyTo: self ])! !

!PRDecorated methodsFor: 'removing' stamp: 'lr 4/10/2007 21:48'!
removeDecoration: aDecoration
	"Remove ==aDecoration== from the receiver, an error is raised if ==aDecoration== is not part of the receiver."

	^ self
		removeDecoration: aDecoration
		ifAbsent: [ PRDecorationError signal: 'Decoration is not part of receiver.' ]! !

!PRDecorated methodsFor: 'removing' stamp: 'lr 4/10/2007 21:48'!
removeDecoration: aDecoration ifAbsent: aBlock
	"Remove ==aDecoration== from the receiver, ==aBlock== is evaluated if ==aDecoration== is not part of the receiver."

	| decoration |
	decoration := self decorations
		detect: [ :each | aDecoration = each ]
		ifNone: [ ^ aBlock value ].
	self setDecorations: (self decorations
		copyWithout: (decoration
			setDecorated: nil;
			yourself)).
	^ decoration! !

!PRDecorated methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setDecorations: anArray
	decorations := anArray! !

PRDecorated subclass: #PRStructure
	instanceVariableNames: 'parent name title tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRStructure commentStamp: 'lr 5/28/2006 17:41' prior: 0!
I am an abstract structure, representing the model of a single page. I've got a name, that must be unique within the scope of my parent, and a title. A structure is identified with a path of structure names.!

PRStructure subclass: #PRCase
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRCase commentStamp: 'lr 1/15/2007 21:42' prior: 0!
I am an abstract class holding onto a document definition representing the contents of the receiver. Most of my subclasses will allow user to edit myself using the Wiki syntax.!

!PRCase class methodsFor: 'accessing-description' stamp: 'lr 10/18/2007 17:36'!
descriptionDocument
	^ PRDocumentDescription new
		selectorAccessor: #document;
		label: 'Contents';
		priority: 500;
		beEditable;
		yourself! !

!PRCase class methodsFor: 'accessing-description' stamp: 'lr 9/13/2007 10:16'!
descriptionPlainText
	^ MAMemoDescription new
		selectorAccessor: #plainText;
		label: 'Plain Text';
		beSearchable;
		priority: 510;
		beReadonly;
		yourself! !

!PRCase methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitCase: self! !

!PRCase methodsFor: 'accessing-dynamic' stamp: 'lr 10/18/2007 17:46'!
contents
	"Answer a wiki string representation of the receiving document."
	
	^ self class descriptionDocument toString: self document! !

!PRCase methodsFor: 'accessing-dynamic' stamp: 'lr 10/18/2007 17:47'!
contents: aString
	self document: (self class descriptionDocument 
		fromString: (aString ifNil: [ String new ]))! !

!PRCase methodsFor: 'accessing-defaults' stamp: 'lr 10/17/2007 22:52'!
defaultDocument
	"Answer the default document of the receiver."

	^ PRDocument new
! !

!PRCase methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:35'!
document
	"Answer the document of the receiver."

	^ document! !

!PRCase methodsFor: 'accessing' stamp: 'lr 10/18/2007 17:43'!
document: aDocument
	document := aDocument.
	document ifNotNil: [ document owner: self ]! !

!PRCase methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasDocument
	^ self document notNil! !

!PRCase methodsFor: 'initialization' stamp: 'lr 1/15/2007 22:05'!
initialize
	super initialize.
	self document: self defaultDocument! !

!PRCase methodsFor: 'accessing-dynamic' stamp: 'lr 10/18/2007 17:31'!
plainText
	"Answer a plain text representation of the receiver's document."
	
	^ PRTextWriter write: self document! !

!PRCase methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopy
	super postCopy.
	self document: self document copy! !

PRCase subclass: #PRPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRPage commentStamp: 'lr 1/15/2007 21:42' prior: 0!
I am the most important class of the structure hierarchy.!

!PRPage class methodsFor: 'testing' stamp: 'lr 1/15/2007 21:35'!
isAbstract
	^ false! !

!PRPage methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitPage: self! !

!PRPage methodsFor: 'accessing-configuration' stamp: 'lr 4/5/2007 14:33'!
defaultDocument
	^ super defaultDocument
		add: (PRParagraph new
			add: (PRText content: 'Edit this page ...');
			yourself);
		yourself! !

PRStructure subclass: #PRFile
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRFile commentStamp: 'lr 6/2/2006 10:54' prior: 0!
I represent a data container for images, videos, sound, pdf or zip files. I reference an instance of *MAFileModel*. The mime-type is used to determine how the given file is be displayed. As an example images and videos are attempted to be inlined into the resulting output, whereas zip-files are referenced as a link to allow downloading.!

!PRFile class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 23:04'!
descriptionFile
	^ MAFileDescription new
		kind: MAExternalFileModel;
		selectorAccessor: #file;
		priority: 300;
		label: 'File';
		beEditable;
		yourself! !

!PRFile class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRFile methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitFile: self! !

!PRFile methodsFor: 'accessing' stamp: 'lr 11/14/2007 20:15'!
file
	^ file ifNil: [ file := self class descriptionFile kind new ]! !

!PRFile methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
file: aFile
	file := aFile! !

!PRFile methodsFor: 'testing' stamp: 'lr 1/29/2007 17:10'!
isFile
	^ true! !

!PRFile methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopy
	super postCopy.
	self file: self file copy! !

!PRStructure class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
canBeChildOf: aStructureClass
	^ true! !

!PRStructure class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
canBeParentOf: aStructureClass
	^ true! !

!PRStructure class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 23:05'!
descriptionName
	^ MAStringDescription new
		selectorAccessor: #name;
		label: 'Name';
		beSearchable;
		beRequired;
		yourself! !

!PRStructure class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 23:05'!
descriptionParent
	^ PRStructureDescription new
		selectorAccessor: #parent;
		label: 'Parent';
		beReadonly;
		beHidden;
		yourself! !

!PRStructure class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 23:05'!
descriptionRoot
	^ PRStructureDescription new
		selectorAccessor: #root;
		label: 'Root';
		beReadonly;
		beHidden;
		yourself! !

!PRStructure class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 23:06'!
descriptionTags
	^ MATokenDescription new
		selectorAccessor: #tags;
		priority: 110;
		label: 'Tags';
		beSearchable;
		beEditable;
		yourself! !

!PRStructure class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 23:06'!
descriptionTitle
	^ MAStringDescription new
		selectorAccessor: #title;
		beSearchable;
		priority: 100;
		label: 'Title';
		beRequired;
		beEditable;
		yourself! !

!PRStructure class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
named: aString
	^ self new
		name: aString;
		yourself! !

!PRStructure methodsFor: 'comparing' stamp: 'lr 8/24/2006 22:46'!
< aStructure
	^ self title < aStructure title! !

!PRStructure methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitStructure: self! !

!PRStructure methodsFor: 'accessing-children' stamp: 'lr 4/10/2007 21:50'!
addChild: aStructure
	"Add ==aStructure== as child to the receiver."

	^ self childrenDecoration add: aStructure! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/10/2007 21:50'!
canBeChildOf: aStructure
	"Answer ==true== if the receiver can be a child of ==aStructure==."

	^ self class canBeChildOf: aStructure class! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/10/2007 21:50'!
canBeParentOf: aStructure
	"Answer ==true== if the receiver can be a parent of ==aStructure==."

	^ self class canBeParentOf: aStructure class! !

!PRStructure methodsFor: 'decorations' stamp: 'lr 9/25/2006 08:13'!
childrenDecoration
	"Answer a decoration with the children of the receiver. If no children exist, an empty children decoration is added to the receiver. Don't call this method directly to avoid empty children decorations."

	^ self
		decorationOfClass: self childrenDecorationClass
		ifAbsent: [ self addDecoration: self childrenDecorationClass new ]! !

!PRStructure methodsFor: 'decorations' stamp: 'lr 3/9/2006 11:30'!
childrenDecorationClass
	^ PRChildren! !

!PRStructure methodsFor: 'accessing-commands' stamp: 'cdlm 8/7/2007 01:30'!
defaultCommandClass
	^ self viewCommandClass! !

!PRStructure methodsFor: 'accessing-commands' stamp: 'lr 6/2/2006 09:20'!
editCommandClass
	"Answer an instance of the default edit command of the receiver."

	^ PREditCommand! !

!PRStructure methodsFor: 'accessing-children' stamp: 'lr 3/9/2006 11:30'!
enumerator
	"Answer an enumerator on the children of the receiver."

	^ PRChildrenVisitor on: self! !

!PRStructure methodsFor: 'accessing-children' stamp: 'lr 10/30/2006 20:15'!
fullTextSearch
	"Answer a visitor searching for text starting at the receiver."

	^ PRFullTextSearch on: self! !

!PRStructure methodsFor: 'testing' stamp: 'lr 9/27/2007 10:04'!
hasChildren
	"Answer ==true== if the receiver has got children, they might not be visible however."

	self enumerator 
		do: [ :each | ^ true ].
	^ false! !

!PRStructure methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasDocument
	^ false! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/10/2007 21:54'!
hasParent
	"Answer ==true== if the receiver has got a parent. This is the negation of ==#isRoot==."

	^ self parent notNil! !

!PRStructure methodsFor: 'accessing-children' stamp: 'lr 4/10/2007 21:51'!
incomingReferences
	"Answer a visitor on incoming references to structures being sepcified (using ==to:== and ==toAll:==) to the visitor before starting. The search will take off from the receiver."

	^ PRIncomingReferences on: self! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/10/2007 21:51'!
isAllowedCommand: aCommandClass in: aContext
 	"Answer ==true== if the receiver accepts ==aCommandClass== as allowed in ==aContext== on the receiver. If a command class is allowed is a security question and should therefore only depend on the permissions in the current context. The default implementation delegates the decision to the decorations of the receiver. Therefor this method should never be overridden by subclasses."

	^ self decorations allSatisfy: [ :each |
		each
			isAllowedCommand: aCommandClass
			in: aContext ]! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/10/2007 21:51'!
isAncestorOf: aStructure
	"Answer ==true== if the receiver is an ancestor of ==aStructure==."

	^ aStructure parents includes: self! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/10/2007 21:51'!
isApplyableCommand: aCommandClass in: aContext
 	"Answer ==true== if the receiver accepts ==aCommandClass== as applyable in ==aContext== on the receiver. If a command class is applyable or not is a question of saneness and compatibility, not of security. This method should be overridden by subclasses who want to forbid some commands."

	^ self isKindOf: aCommandClass structureClass! !

!PRStructure methodsFor: 'testing' stamp: 'lr 1/29/2007 17:09'!
isFile
	^ false! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/10/2007 21:51'!
isRoot
	"Answer ==true== if the receiver is the root of the Pier model. This is the negation of ==#hasParent==."

	^ self parent isNil! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/10/2007 21:52'!
isValidCommand: aCommandClass in: aContext
 	"Answer ==true== if the receiver accepts to execute ==aCommandClass== in ==aContext==. This message is the combination of ==#isApplyableCommand:in:== and ==#isAllowedCommand:in:==. It should not be overridden."

	^ (self isApplyableCommand: aCommandClass in: aContext)
		and: [ self isAllowedCommand: aCommandClass in: aContext ]! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 4/20/2007 08:30'!
kernel
	"Answer the kernel of the receiver."

	| root |
	root := self root.
	^ PRKernel instances
		detect: [ :each | each realize root = root ]
		ifNone: [ self error: self title , ' is not part of a kernel.' ]! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 2/3/2007 12:40'!
level
	"Answer the nesting level of the receiver."

	^ self isRoot
		ifTrue: [ 1 ]
		ifFalse: [ self parent level + 1 ]! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
name
	"Answer the name of the receiver. The name should be simple and only contain letters and numbers, since it is used as an identifier within restrictive protocols."

	^ name! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
name: aString
	name := aString! !

!PRStructure methodsFor: 'accessing-children' stamp: 'lr 4/10/2007 21:52'!
outgoingReferences
	"Answer a visitor on all outgoing references taking off at the reciver. The visited objects are instances of ==*PRInternalLink*==."

	^ PROutgoingReferences on: self! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
parent
	"Answer the parent structure of the receiver."

	^ parent! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
parent: aStructure
	parent := aStructure! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 6/2/2006 09:22'!
parents
	"Answer an ordered collection of all the parents of the receiver up and including the receiver itself."

	^ self isRoot
		ifTrue: [ OrderedCollection with: self ]
		ifFalse: [
			self parent parents
				addLast: self;
				yourself ]! !

!PRStructure methodsFor: 'copying' stamp: 'lr 8/17/2007 07:58'!
postCopy
	super postCopy.
	self parent: nil.
	self tags: self tags copy! !

!PRStructure methodsFor: 'copying' stamp: 'lr 3/9/2006 11:30'!
postCopyTo: anObject
	self parent: anObject! !

!PRStructure methodsFor: 'printing' stamp: 'lr 3/9/2006 11:30'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' name: '; print: self name! !

!PRStructure methodsFor: 'actions' stamp: 'lr 6/2/2006 09:22'!
remove
	"Remove the receiver from the parent structure."

	self parent childrenDecoration remove: self! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:30'!
root
	"Answer the root structure of the receiver."

	^ self isRoot
		ifTrue: [ self ]
		ifFalse: [ self parent root ]! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 4/5/2007 17:59'!
tags
	"Answer a list of tags specific to the receiver."

	^ tags ifNil: [ tags := #() ]! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2007 14:20'!
tags: anArray
	tags := anArray! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
title
	"Answer the title of the receiver, essentially the name but starting uppercase."

	^ title ifNil: [ title := self name capitalized ]! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
title: aString
	title := aString! !

!PRStructure methodsFor: 'testing' stamp: 'lr 4/10/2007 21:52'!
validateCommand: aCommand
 	"Validates ==Command== to be executed within the context of the reicever. Throw an exception if there is something wrong with the command."

	self decorations do: [ :each | each validateCommand: aCommand ]! !

!PRStructure methodsFor: 'accessing-commands' stamp: 'lr 6/2/2006 09:20'!
viewCommandClass
	"Answer the default view command of the receiver. Most likely you never need to change the default implementation."

	^ PRViewCommand! !

PRObject subclass: #PRDecoration
	instanceVariableNames: 'decorated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRDecoration commentStamp: 'lr 5/30/2006 19:16' prior: 0!
I am an abstract decoration to add new behaviour and data to structures. Every decoration knows its owner, a subclass of *PRDecorated*. Decorations are considered to be equal if they are of the same species, but subclasses might want to refine this behaviour to be able to add multiple instances of the same class.

Within the owner decorations are ordered according to their priority. Decorations with a negative priority are visited before the owner, decorations with a positive one after the owner.!

PRDecoration subclass: #PRChildren
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRChildren commentStamp: 'lr 5/28/2006 17:47' prior: 0!
I hold the children of the decorated object.!

!PRChildren class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRChildren methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitChildren: self! !

!PRChildren methodsFor: 'actions' stamp: 'lr 4/10/2007 21:43'!
add: aStructure
	"Add ==aStructure== as a child to the receiver."

	self children
		at: aStructure name
		put: (aStructure
			parent: self decorated;
			yourself).
	self triggerStructureAdded: aStructure.
	^ aStructure! !

!PRChildren methodsFor: 'accessing-children' stamp: 'lr 4/10/2007 21:43'!
at: aString
	"Answer the child structure with the name ==aString==, raise an error if the child can't be found."

	^ self at: aString ifAbsent: [ self error: 'Child not found.' ]! !

!PRChildren methodsFor: 'accessing-children' stamp: 'lr 4/10/2007 21:43'!
at: aString ifAbsent: aBlock
	"Answer the child structure with the name ==aString==, evaluate ==aBlock== if the child can't be found."

	^ self children at: aString ifAbsent: aBlock! !

!PRChildren methodsFor: 'accessing-children' stamp: 'lr 3/9/2006 11:29'!
at: aString ifPresent: aBlock
	^ self children at: aString ifPresent: aBlock! !

!PRChildren methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
children
	^ children! !

!PRChildren methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:29'!
childrenCollection
	^ Dictionary new! !

!PRChildren methodsFor: 'enumerating' stamp: 'lr 3/9/2006 11:29'!
do: aBlock
	self children do: aBlock! !

!PRChildren methodsFor: 'enumerating' stamp: 'lr 9/24/2007 19:19'!
do: aBlock sorted: aSortBlock
	self children values asArray
		sort: aSortBlock;
		do: aBlock! !

!PRChildren methodsFor: 'accessing-children' stamp: 'lr 3/9/2006 11:29'!
includes: aString
	^ self children includesKey: aString! !

!PRChildren methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
initialize
	super initialize.
	self setChildren: self childrenCollection! !

!PRChildren methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isEmpty
	^ children isEmpty! !

!PRChildren methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isValidChild: aStructure
	^ aStructure name notNil
		and: [ aStructure name notEmpty
		and: [ aStructure parent isNil
		and: [ (self includes: aStructure name) not
		and: [ (self decorated canBeParentOf: aStructure)
		and: [ (aStructure canBeChildOf: self decorated) ] ] ] ] ]! !

!PRChildren methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopyTo: anObject
	super postCopyTo: anObject.
	self setChildren: self children copy.
	self children keysAndValuesDo: [ :key :value |
		self children at: key put: (value copy
			postCopyTo: self decorated) ]! !

!PRChildren methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
priority
	^ 200! !

!PRChildren methodsFor: 'actions' stamp: 'lr 4/10/2007 21:43'!
remove: aStructure
	"Remove ==aStructure== from the receiver."

	self children keysAndValuesDo: [ :key :value |
		aStructure = value ifTrue: [
			self children removeKey: key.
			self triggerStructureRemoved: value.
			self isEmpty ifTrue: [ self remove ].
			^ value
				parent: nil;
				yourself ] ].
	^ nil! !

!PRChildren methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setChildren: aCollection
	children := aCollection! !

!PRChildren methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:47'!
size
	"Answer the number of children of the receiver."

	^ self children size! !

!PRChildren methodsFor: 'events' stamp: 'lr 3/9/2006 11:29'!
triggerStructureAdded: aStructure
	PRDecoration withAllConcreteClassesDo: [ :each | each onStructureAdded: aStructure ]! !

!PRChildren methodsFor: 'events' stamp: 'lr 3/9/2006 11:29'!
triggerStructureRemoved: aStructure
	PRDecoration withAllConcreteClassesDo: [ :each | each onStructureRemoved: aStructure ]! !

!PRDecoration class methodsFor: 'events' stamp: 'lr 3/9/2006 11:30'!
onStructureAdded: aStructure
	"This event is called whenever a structure is added as a child to another structure."! !

!PRDecoration class methodsFor: 'events' stamp: 'lr 3/9/2006 11:30'!
onStructureRemoved: aStructure
	"This event is called whenever a structure is removed as a child from another structure."! !

!PRDecoration methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
<= aDecoration
	^ self priority <= aDecoration priority! !

!PRDecoration methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= aDecoration
	^ self species = aDecoration species! !

!PRDecoration methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:45'!
decorated
	"Answer the owner of the receiver, the decorated object."

	^ decorated! !

!PRDecoration methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ self species hash! !

!PRDecoration methodsFor: 'testing' stamp: 'lr 4/10/2007 21:48'!
isAllowedCommand: aCommandClass in: aContext
 	"Answer ==true== if the receiver allows one to execute ==aCommandClass== in ==aContext==. The default decoration is fine with all the commands, subclasses might restrict to a selected set of commands within a given context. This method might be overridden by decorations that want to control the security."

	^ true! !

!PRDecoration methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopy
	super postCopy.
	self setDecorated: nil! !

!PRDecoration methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopyTo: anObject
	super postCopyTo: anObject.
	self setDecorated: anObject! !

!PRDecoration methodsFor: 'accessing' stamp: 'lr 5/29/2006 09:27'!
priority
	"The default priority returns a number that defines in witch order the visitors will traverse through decorated objects. Negative numbers are visited before the decorated objects, positive numbers afterwards."

	^ self subclassResponsibility! !

!PRDecoration methodsFor: 'utilities' stamp: 'lr 3/9/2006 11:29'!
remove
	self decorated notNil
		ifFalse: [ ^ self ].
	self decorated
		removeDecoration: self
		ifAbsent: [ ]! !

!PRDecoration methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setDecorated: aStructure
	decorated := aStructure! !

!PRDecoration methodsFor: 'testing' stamp: 'lr 4/10/2007 21:48'!
validateCommand: aCommand
 	"Validates ==Command== to be executed within the context of the reicever."! !

PRObject subclass: #PRDocumentItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDocumentItem commentStamp: 'lr 5/28/2006 20:30' prior: 0!
I am an abstract superclass for the document hierarchy. My subclasses include all the basic elements to represent a document.!

PRDocumentItem subclass: #PRAnchor
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRAnchor commentStamp: 'lr 5/29/2006 09:30' prior: 0!
I am an anchor within a document. I am used as a reference point within a large document.!

!PRAnchor class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 19:01'!
descriptionName
	^ (MAStringDescription new)
		selectorAccessor: #name;
		label: 'Name';
		yourself! !

!PRAnchor class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRAnchor class methodsFor: 'accessing' stamp: 'lr 4/5/2007 13:10'!
markup
	^ '@'! !

!PRAnchor class methodsFor: 'instance-creation' stamp: 'lr 4/5/2007 13:08'!
named: aString
	^ self new name: aString! !

!PRAnchor class methodsFor: 'instance-creation' stamp: 'lr 4/24/2007 20:45'!
parse: aString with: aParser
	^ aParser add: (self named: (aString allButFirst: self markup size))! !

!PRAnchor methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= anObject
	^ super = anObject
		and: [ self name = anObject name ]! !

!PRAnchor methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitAnchor: self! !

!PRAnchor methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ super hash bitXor: self name hash! !

!PRAnchor methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
name
	^ name! !

!PRAnchor methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
name: aString
	name := aString! !

PRDocumentItem subclass: #PRDocumentGroup
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDocumentGroup commentStamp: 'lr 5/28/2006 20:33' prior: 0!
I am an abstract group of document items.!

PRDocumentGroup subclass: #PRDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDocument commentStamp: 'lr 5/28/2006 21:06' prior: 0!
I am the root of a document composite.!

!PRDocument class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRDocument methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitDocument: self! !

!PRDocumentGroup class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 23:03'!
descriptionText
	^ MANumberDescription new
		selectorAccessor: #size;
		label: 'Size';
		beReadonly;
		yourself! !

!PRDocumentGroup class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
with: aDocumentItem
	^ self new
		add: aDocumentItem;
		yourself! !

!PRDocumentGroup class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
withAll: aCollection
	^ self new
		addAll: aCollection;
		yourself! !

!PRDocumentGroup class methodsFor: 'instance-creation' stamp: 'lr 4/5/2007 11:19'!
withAll: aCollection markup: aString
	^ self withAll: aCollection! !

!PRDocumentGroup methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= anObject
	^ super = anObject
		and: [ self children = anObject children ]! !

!PRDocumentGroup methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitDocumentGroup: self! !

!PRDocumentGroup methodsFor: 'adding' stamp: 'lr 3/20/2006 19:06'!
add: aDocumentItem
	self setChildren: (self children copyWith: aDocumentItem)! !

!PRDocumentGroup methodsFor: 'adding' stamp: 'lr 7/31/2007 21:22'!
addAll: aCollection
	self setChildren: self children , aCollection! !

!PRDocumentGroup methodsFor: 'enumerating' stamp: 'lr 5/28/2007 16:31'!
allChildrenDo: aBlock
	self children do: [ :each |
		aBlock value: each.
		each allChildrenDo: aBlock ]! !

!PRDocumentGroup methodsFor: 'accessing' stamp: 'lr 5/28/2006 20:32'!
children
	"Answer the children of the receiver."

	^ children! !

!PRDocumentGroup methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasChildren
	^ self children notEmpty! !

!PRDocumentGroup methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ super hash bitXor: self children hash! !

!PRDocumentGroup methodsFor: 'initialization' stamp: 'lr 4/4/2007 15:05'!
initialize
	super initialize.
	self setChildren: #()! !

!PRDocumentGroup methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
owner: anObject
	super owner: anObject.
	self children do: [ :each | each owner: anObject ]! !

!PRDocumentGroup methodsFor: 'copying' stamp: 'lr 2/12/2007 19:07'!
postCopy
	super postCopy.
	self setChildren: (self children
		collect: [ :each | each copy ])! !

!PRDocumentGroup methodsFor: 'initialization' stamp: 'lr 3/20/2006 19:06'!
setChildren: aCollection
	children := aCollection! !

!PRDocumentGroup methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
size
	^ self children size! !

!PRDocumentGroup methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
text
	^ String streamContents: [ :stream |
		self children do: [ :each |
			stream nextPutAll: each text ] ]! !

PRDocumentGroup subclass: #PRFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

PRFormat subclass: #PRBoldFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRBoldFormat class methodsFor: 'testing' stamp: 'lr 3/30/2007 19:40'!
isAbstract
	^ false! !

!PRBoldFormat class methodsFor: 'accessing' stamp: 'lr 4/5/2007 15:36'!
markup
	^ '""'! !

!PRBoldFormat methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitBoldFormat: self! !

!PRFormat class methodsFor: 'accessing' stamp: 'lr 9/27/2007 10:32'!
markup
	self subclassResponsibility! !

!PRFormat class methodsFor: 'instance-creation' stamp: 'lr 4/24/2007 21:10'!
parse: aString with: aParser
	^ self withAll: (aParser parseText: (aString copyFrom: self markup size + 1 to: aString size - self markup size))! !

!PRFormat methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitFormat: self! !

PRFormat subclass: #PRItalicFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRItalicFormat class methodsFor: 'testing' stamp: 'lr 3/30/2007 19:40'!
isAbstract
	^ false! !

!PRItalicFormat class methodsFor: 'accessing' stamp: 'lr 4/5/2007 15:36'!
markup
	^ ''''''! !

!PRItalicFormat methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitItalicFormat: self! !

PRFormat subclass: #PRMonospaceFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRMonospaceFormat class methodsFor: 'testing' stamp: 'lr 3/30/2007 19:40'!
isAbstract
	^ false! !

!PRMonospaceFormat class methodsFor: 'accessing' stamp: 'lr 3/30/2007 20:40'!
markup
	^ '=='! !

!PRMonospaceFormat methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitMonospaceFormat: self! !

PRFormat subclass: #PRStrikethroughFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRStrikethroughFormat class methodsFor: 'testing' stamp: 'lr 3/30/2007 19:40'!
isAbstract
	^ false! !

!PRStrikethroughFormat class methodsFor: 'accessing' stamp: 'lr 3/30/2007 19:44'!
markup
	^ '--'! !

!PRStrikethroughFormat methodsFor: 'visiting' stamp: 'lr 5/31/2007 07:46'!
accept: aVisitor
	aVisitor visitStrikethroughFormat: self! !

PRFormat subclass: #PRSubscriptFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRSubscriptFormat class methodsFor: 'testing' stamp: 'lr 3/30/2007 19:40'!
isAbstract
	^ false! !

!PRSubscriptFormat class methodsFor: 'accessing' stamp: 'lr 3/30/2007 19:46'!
markup
	^ '@@'! !

!PRSubscriptFormat methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitSubscriptFormat: self! !

PRFormat subclass: #PRSuperscriptFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRSuperscriptFormat class methodsFor: 'testing' stamp: 'lr 3/30/2007 19:40'!
isAbstract
	^ false! !

!PRSuperscriptFormat class methodsFor: 'accessing' stamp: 'lr 3/30/2007 19:45'!
markup
	^ '^^'! !

!PRSuperscriptFormat methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitSuperscriptFormat: self! !

PRFormat subclass: #PRUnderlineFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRUnderlineFormat class methodsFor: 'testing' stamp: 'lr 3/30/2007 19:43'!
isAbstract
	^ false! !

!PRUnderlineFormat class methodsFor: 'accessing' stamp: 'lr 3/30/2007 19:43'!
markup
	^ '__'! !

!PRUnderlineFormat methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitUnderlineFormat: self! !

PRDocumentGroup subclass: #PRHeader
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRHeader commentStamp: 'lr 5/28/2006 20:34' prior: 0!
I represent a header within a document. My level is a natural number.!

!PRHeader class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 19:01'!
descriptionLevel
	^ (MANumberDescription new)
		selectorAccessor: #level;
		label: 'Level';
		yourself! !

!PRHeader class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRHeader class methodsFor: 'accessing' stamp: 'lr 4/5/2007 13:10'!
markup
	^ '!!'! !

!PRHeader class methodsFor: 'instance-creation' stamp: 'lr 4/24/2007 21:27'!
parse: aString with: aParser
	| index string |
	index := 0. string := aString.
	[ string beginsWith: self markup ] whileTrue: [
		index := index + 1.
		string := string allButFirst: self markup size ].
	^ aParser add: (self withAll: (aParser parseText: string) level: index)! !

!PRHeader class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
withAll: aCollection level: anInteger
	^ (self withAll: aCollection)
		level: anInteger;
		yourself! !

!PRHeader methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= anObject
	^ super = anObject
		and: [ self level = anObject level ]! !

!PRHeader methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitHeader: self! !

!PRHeader methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ super hash bitXor: self level hash! !

!PRHeader methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
level
	^ level! !

!PRHeader methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
level: anInteger
	level := anInteger! !

PRDocumentGroup subclass: #PRLink
	instanceVariableNames: 'reference embedded parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRLink commentStamp: 'lr 5/28/2006 21:02' prior: 0!
I am an abstract link built from an alias and a reference. The alias is the string representation that will be displayed to the user, whereas the reference is a string identifying the target. If there is no alias, the reference itself is displayed. Links can try to embed the referenced target into the containing document.

!!Examples
=*Reference*
=+Alias>Embedded Reference*!

PRLink subclass: #PRExternalLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRExternalLink commentStamp: 'lr 5/28/2006 20:41' prior: 0!
I am an abstract external link with an URL (Uniform Resource Locator) as reference.!

!PRExternalLink class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 19:01'!
descriptionUrl
	^ ((MAStringDescription new)
		selectorAccessor: #url;
		label: 'Url';
		yourself) beReadonly! !

!PRExternalLink class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRExternalLink class methodsFor: 'testing' stamp: 'lr 8/26/2007 17:36'!
isValidReference: aString
	^ aString includesSubString: '://'! !

!PRExternalLink class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
priority
	^ 40! !

!PRExternalLink methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitExternalLink: self! !

!PRExternalLink methodsFor: 'accessing' stamp: 'lr 5/28/2006 20:41'!
url
	"Answer the URL the receiver is pointing to."

	^ String streamContents: [ :stream |
		stream
			nextPutAll: self urlPrefix;
			nextPutAll: self urlEntry;
			nextPutAll: self urlPostfix ]! !

!PRExternalLink methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
urlEntry
	^ self reference! !

!PRExternalLink methodsFor: 'accessing-dynamic' stamp: 'lr 10/20/2006 11:43'!
urlPostfix
	^ ''! !

!PRExternalLink methodsFor: 'accessing-dynamic' stamp: 'lr 10/20/2006 11:43'!
urlPrefix
	^ ''! !

PRExternalLink subclass: #PRGoogleLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRGoogleLink class methodsFor: 'testing' stamp: 'lr 8/26/2007 17:35'!
isValidReference: aString
	^ aString beginsWith: 'google:'! !

!PRGoogleLink class methodsFor: 'accessing' stamp: 'lr 9/4/2006 11:31'!
priority
	^ 20! !

!PRGoogleLink methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitGoogleLink: self! !

!PRGoogleLink methodsFor: 'accessing-dynamic' stamp: 'lr 2/7/2007 15:15'!
title
	^ 'Google (' , self urlEntry , ')'! !

!PRGoogleLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/4/2006 11:31'!
urlEntry
	^ super urlEntry copyAfter: $:! !

!PRGoogleLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/4/2006 11:30'!
urlPrefix
	^ 'http://www.google.com/search?q='! !

PRExternalLink subclass: #PRIsbnLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRIsbnLink commentStamp: 'lr 5/28/2006 20:46' prior: 0!
I am an external link pointing to an ISBN (International Standard Book Number).!

!PRIsbnLink class methodsFor: 'testing' stamp: 'lr 8/26/2007 17:35'!
isValidReference: aString
	^ aString beginsWith: 'isbn:'! !

!PRIsbnLink class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
priority
	^ 20! !

!PRIsbnLink methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitIsbnLink: self! !

!PRIsbnLink methodsFor: 'accessing-dynamic' stamp: 'lr 10/20/2006 11:42'!
title
	^ 'ISBN ' , self urlEntry! !

!PRIsbnLink methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
urlEntry
	^ super urlEntry copyAfter: $:! !

!PRIsbnLink methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
urlPrefix
	^ 'http://www.amazon.com/exec/obidos/ISBN='! !

PRExternalLink subclass: #PRMailLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRMailLink commentStamp: 'lr 6/2/2006 11:29' prior: 0!
I am an external link pointing to a mail address. I encode my URL to prevent spam bots collecting the address.!

!PRMailLink class methodsFor: 'testing' stamp: 'lr 1/29/2008 18:10'!
isValidReference: aString
	| index |
	index := aString indexOf: $@ ifAbsent: [ ^ false ].
	index := aString indexOf: $. startingAt: index ifAbsent: [ ^ false ].
	^ aString allSatisfy: [ :each | each isLetter or: [ '@-.' includes: each ] ]! !

!PRMailLink class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
priority
	^ 10! !

!PRMailLink methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitMailLink: self! !

!PRMailLink methodsFor: 'accessing-dynamic' stamp: 'lr 5/24/2006 11:12'!
urlEntry
	^ String streamContents: [ :stream |
		super urlEntry do: [ :each |
			2 atRandom = 1
				ifTrue: [ stream nextPut: each ]
				ifFalse: [ stream nextPut: $%; nextPutAll: ((each asciiValue printStringBase: 16)
		padded: #left to: 2 with: $0) ] ] ]! !

!PRMailLink methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
urlPrefix
	^ 'mailto:'! !

PRExternalLink subclass: #PRRfcLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRRfcLink commentStamp: 'lr 5/28/2006 20:46' prior: 0!
I am an external link pointing to a RFC (Request for Comments) document.!

!PRRfcLink class methodsFor: 'testing' stamp: 'lr 8/26/2007 17:35'!
isValidReference: aString
	^ aString beginsWith: 'rfc:'! !

!PRRfcLink class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
priority
	^ 30! !

!PRRfcLink methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitRfcLink: self! !

!PRRfcLink methodsFor: 'accessing-dynamic' stamp: 'lr 10/20/2006 12:06'!
title
	^ 'RFC ' , self urlEntry! !

!PRRfcLink methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
urlEntry
	^ super urlEntry copyAfter: $:! !

!PRRfcLink methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
urlPostfix
	^ '.html'! !

!PRRfcLink methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
urlPrefix
	^ 'http://www.faqs.org/rfcs/rfc'! !

PRLink subclass: #PRInternalLink
	instanceVariableNames: 'owner target anchor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRInternalLink commentStamp: 'lr 4/10/2007 21:12' prior: 0!
I am an internal link pointing to a structure within the current kernel. I reference my owning structure to be able to lookup the referenced structure. The referenced structure is cached in the instance variable ==target==.!

!PRInternalLink class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 19:01'!
descriptionAnchor
	^ (MAStringDescription new)
		selectorAccessor: #anchor;
		label: 'Anchor';
		yourself! !

!PRInternalLink class methodsFor: 'accessing-description' stamp: 'lr 12/8/2007 17:09'!
descriptionTarget
	^ PRStructureDescription new
		selectorAccessor: #target;
		label: 'Target';
		yourself! !

!PRInternalLink class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRInternalLink class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isValidReference: aString
	^ true! !

!PRInternalLink class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
priority
	^ 50! !

!PRInternalLink class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
reference: aString
	| index |
	^ (index := aString indexOf: $@) isZero
		ifTrue: [ super reference: aString ]
		ifFalse: [
			self new
				reference: (aString copyFrom: 1 to: index - 1);
				anchor: (aString copyFrom: index + 1 to: aString size);
				yourself ]! !

!PRInternalLink methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= anObject
	^ super = anObject
		and: [ self anchor = anObject anchor ]! !

!PRInternalLink methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitInternalLink: self! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 5/28/2006 20:48'!
anchor
	"Answer an anchor string the receiver is pointing to."

	^ anchor! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
anchor: aString
	anchor := aString! !

!PRInternalLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasAnchor
	^ self anchor notNil! !

!PRInternalLink methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ super hash bitXor: self anchor hash! !

!PRInternalLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isBroken
	^ self target isNil! !

!PRInternalLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isInternal
	^ true! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
owner
	^ owner! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 1/29/2008 10:15'!
owner: anObject
	super owner: (owner := anObject)! !

!PRInternalLink methodsFor: 'actions' stamp: 'lr 4/10/2007 21:49'!
refresh
	"This message will be sent by the structure whenever it is parsed and the references have to be set up. It simply starts a look-up in the owner using the reference-string. In case the reference is invalid the target will be set to ==nil== and the receiver is in a broken-state."

	self target: (PRPathLookup
		start: self owner
		path: self reference
		onError: [ nil ])! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 5/28/2006 20:48'!
target
	"Answer the referenced structure."

	(target isNil and: [ self hasOwner ])
		ifTrue: [ self refresh ].
	^ target! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
target: aStructure
	target := aStructure! !

!PRInternalLink methodsFor: 'accessing-dynamic' stamp: 'lr 2/12/2007 19:07'!
title
	^ self target isNil
		ifTrue: [ super title ]
		ifFalse: [ self target title ]! !

!PRInternalLink methodsFor: 'actions' stamp: 'lr 10/21/2007 16:50'!
update
	"This method will be sent to all the internal-links whenever the owner is renamed or moved to a different location in the structure tree. It automatically adjusts the receivers state, so that the reference still points to the right location and doesn't get broken."

	self reference: (PRPathReference
		from: self owner
		to: self target)! !

!PRLink class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 23:04'!
descriptionAlias
	^ MAStringDescription new
		selectorAccessor: #alias;
		label: 'Alias';
		beReadonly;
		yourself! !

!PRLink class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 23:04'!
descriptionHasAlias
	^ MABooleanDescription new
		selectorAccessor: #hasAlias;
		label: 'Aliased';
		beReadonly;
		yourself! !

!PRLink class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 23:04'!
descriptionHasAnchor
	^ MABooleanDescription new
		selectorAccessor: #hasAnchor;
		label: 'Anchored';
		beReadonly;
		yourself! !

!PRLink class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 23:04'!
descriptionIsBroken
	^ MABooleanDescription new
		selectorAccessor: #isBroken;
		label: 'Broken';
		beReadonly;
		yourself! !

!PRLink class methodsFor: 'accessing-description' stamp: 'lr 8/25/2007 18:17'!
descriptionIsEmbedded
	^ MABooleanDescription new
		selectorAccessor: #isEmbedded;
		label: 'Embedded';
		yourself! !

!PRLink class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 19:01'!
descriptionReference
	^ (MAStringDescription new)
		selectorAccessor: #reference;
		label: 'Reference';
		yourself! !

!PRLink class methodsFor: 'instance-creation' stamp: 'lr 4/5/2007 15:16'!
fromString: aString
	| classes |
	classes := self withAllConcreteClasses
		select: [ :each | each isValidReference: aString ].
	classes sort: [ :a :b | a priority < b priority ].
	^ classes first reference: aString! !

!PRLink class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isValidReference: aString
	self subclassResponsibility! !

!PRLink class methodsFor: 'accessing' stamp: 'lr 4/5/2007 15:13'!
markup
	^ '*'! !

!PRLink class methodsFor: 'accessing' stamp: 'lr 4/5/2007 15:12'!
markupAlias
	^ '>'! !

!PRLink class methodsFor: 'accessing' stamp: 'lr 4/5/2007 15:12'!
markupAnchor
	^ '@'! !

!PRLink class methodsFor: 'accessing' stamp: 'lr 4/5/2007 15:12'!
markupEmbedded
	^ '+'! !

!PRLink class methodsFor: 'accessing' stamp: 'lr 8/26/2007 17:40'!
markupParameter
	^ '|'! !

!PRLink class methodsFor: 'instance-creation' stamp: 'lr 9/12/2007 18:18'!
parse: aString with: aParser
	| string index embedded alias params |
	string := aString copyFrom: self markup size + 1 to: aString size - self markup size.
	embedded := aString beginsWith: self markupEmbedded.

	index := string findString: self markupAlias.
	index isZero
		ifTrue: [ alias := #() ]
		ifFalse: [
			alias := aParser parseText: (string copyFrom: 1 to: index - 1).
			string := string copyFrom: index + 1 to: string size ].

	index := string findString: self markupParameter.
	index isZero
		ifTrue: [ params := #() ]
		ifFalse: [
			params := self parseParameters: (string copyFrom: index + 1 to: string size).
			string := string copyFrom: 1 to: index - 1 ].

	^ (self fromString: string)
		parameters: params;
		embedded: embedded;
		addAll: alias;
		yourself! !

!PRLink class methodsFor: 'instance-creation' stamp: 'lr 9/12/2007 18:18'!
parseParameters: aString
	| input result index parameter |
	input := aString readStream.
	result := OrderedCollection new.
	[ input atEnd ] whileFalse: [
		parameter := input upToAll: self markupParameter.
		parameter isEmpty ifFalse: [
			index := parameter indexOf: $=.
			result add: (index isZero
				ifTrue: [ parameter -> nil ]
				ifFalse: [ (parameter copyFrom: 1 to: index - 1) -> (parameter copyFrom: index + 1 to: parameter size) ]) ] ].
	^ result! !

!PRLink class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
priority
	self subclassResponsibility! !

!PRLink class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
reference: aString
	^ self new
		reference: aString;
		yourself! !

!PRLink methodsFor: 'comparing' stamp: 'lr 8/27/2007 10:28'!
= anObject
	^ super = anObject
		and: [ self reference = anObject reference
		and: [ self embedded = anObject embedded
		and: [ self parameters = anObject parameters ] ] ]! !

!PRLink methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitLink: self! !

!PRLink methodsFor: 'accessing-dynamic' stamp: 'lr 5/28/2006 20:39'!
alias
	"Answer the alias of the receiver or an empty string if none."

	^ self text! !

!PRLink methodsFor: 'accessing' stamp: 'lr 4/10/2007 21:49'!
embedded
	"Answer ==true== if the reference should be embedded."

	^ embedded! !

!PRLink methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
embedded: aBoolean
	embedded := aBoolean! !

!PRLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasAlias
	^ self hasChildren! !

!PRLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasAnchor
	^ false! !

!PRLink methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ super hash bitXor: (self reference hash bitXor: self embedded hash)! !

!PRLink methodsFor: 'initialization' stamp: 'lr 8/27/2007 10:14'!
initialize
	super initialize.
	self embedded: false.
	self parameters: #()! !

!PRLink methodsFor: 'testing' stamp: 'lr 4/10/2007 21:49'!
isBroken
	"Answer ==true== if the receiver is broken."

	^ false! !

!PRLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isEmbedded
	^ self embedded! !

!PRLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isInternal
	^ false! !

!PRLink methodsFor: 'testing' stamp: 'lr 4/16/2007 12:00'!
isLink
	^ true! !

!PRLink methodsFor: 'accessing' stamp: 'lr 9/12/2007 18:18'!
parameters
	"Answer an ordered collection of parameters."

	^ parameters! !

!PRLink methodsFor: 'accessing' stamp: 'lr 8/27/2007 10:41'!
parameters: aCollection
	parameters := aCollection asArray! !

!PRLink methodsFor: 'accessing' stamp: 'lr 5/28/2006 20:39'!
reference
	"Answer the reference of the receiver."

	^ reference! !

!PRLink methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
reference: aString
	reference := aString! !

!PRLink methodsFor: 'accessing-dynamic' stamp: 'lr 12/20/2007 14:32'!
text
	| text |
	text := super text.
	^ text isEmpty 
		ifTrue: [ self reference ]
		ifFalse: [ text ]! !

!PRLink methodsFor: 'accessing-dynamic' stamp: 'lr 10/20/2006 11:40'!
title
	"Answer a title of the link, this is should never be nil."

	^ self reference! !

PRDocumentGroup subclass: #PRList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRList commentStamp: 'lr 5/28/2006 20:55' prior: 0!
I am an abstract list. My children are instances of *PRListItem*.!

PRList subclass: #PRDefinitionList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDefinitionList commentStamp: 'lr 12/30/2007 19:44' prior: 0!
I am an definition list. I am typically used for a keyword and a longer definition string.!

!PRDefinitionList class methodsFor: 'testing' stamp: 'lr 12/30/2007 17:23'!
isAbstract
	^ false! !

!PRDefinitionList methodsFor: 'visiting' stamp: 'lr 12/30/2007 17:23'!
accept: aVisitor
	aVisitor visitDefinitionList: self! !

!PRList class methodsFor: 'instance-creation' stamp: 'lr 12/31/2007 00:04'!
parse: aString with: aParser
	| string types spec class |
	string := aString.
	types := OrderedCollection new.
	spec := class := nil.
	[ (spec := self specificationFor: string) isNil ] whileFalse: [
		string := string allButFirst: spec first size.
		types addLast: spec second.
		class := spec third ].
	^ aParser addListItem: (class withAll: (aParser parseText: string)) ofType: types! !

!PRList class methodsFor: 'accessing' stamp: 'lr 12/30/2007 22:51'!
specificationFor: aString
	(aString beginsWith: PROrderedList markup)
		ifTrue: [ ^ Array with: PROrderedList markup with: PROrderedList with: PRListItem ].
	(aString beginsWith: PRUnorderedList markup)
		ifTrue: [ ^ Array with: PRUnorderedList markup with: PRUnorderedList with: PRListItem ].
	(aString beginsWith: PRTermItem markup)
		ifTrue: [ ^ Array with: PRTermItem markup with: PRDefinitionList with: PRTermItem ].
	(aString beginsWith: PRDataItem markup)
		ifTrue: [ ^ Array with: PRDataItem markup with: PRDefinitionList with: PRDataItem ].
	^ nil! !

!PRList methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitList: self! !

PRList subclass: #PROrderedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PROrderedList commentStamp: 'lr 5/28/2006 20:53' prior: 0!
I am an ordered list. I am typically used for numbered items.!

!PROrderedList class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PROrderedList class methodsFor: 'accessing' stamp: 'lr 4/5/2007 13:12'!
markup
	^ '#'! !

!PROrderedList methodsFor: 'visiting' stamp: 'lr 12/30/2007 19:31'!
accept: aVisitor
	aVisitor visitOrderedList: self! !

PRList subclass: #PRUnorderedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRUnorderedList commentStamp: 'lr 5/28/2006 20:53' prior: 0!
I am an unordered list. I am typically used for unnumbered lists!

!PRUnorderedList class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRUnorderedList class methodsFor: 'accessing' stamp: 'lr 4/5/2007 13:12'!
markup
	^ '-'! !

!PRUnorderedList methodsFor: 'visiting' stamp: 'lr 12/30/2007 19:31'!
accept: aVisitor
	aVisitor visitUnorderedList: self! !

PRDocumentGroup subclass: #PRListItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRListItem commentStamp: 'lr 6/2/2006 11:26' prior: 0!
I am a item within a *PRList*.!

PRListItem subclass: #PRDataItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDataItem class methodsFor: 'accessing' stamp: 'lr 12/30/2007 21:59'!
markup
	^ ':'! !

!PRDataItem methodsFor: 'visiting' stamp: 'lr 12/30/2007 21:50'!
accept: aVisitor
	aVisitor visitDataItem: self! !

!PRListItem class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRListItem methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitListItem: self! !

PRListItem subclass: #PRTermItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRTermItem class methodsFor: 'accessing' stamp: 'lr 12/30/2007 22:00'!
markup
	^ ';'! !

!PRTermItem methodsFor: 'visiting' stamp: 'lr 12/30/2007 21:51'!
accept: aVisitor
	aVisitor visitTermItem: self! !

PRDocumentGroup subclass: #PRParagraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRParagraph commentStamp: 'lr 5/28/2006 20:54' prior: 0!
I am a paragraph of text.!

PRParagraph subclass: #PREmptyParagraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PREmptyParagraph methodsFor: 'visiting' stamp: 'lr 12/20/2007 12:12'!
accept: aVisitor
	aVisitor visitEmptyParagraph: self! !

!PRParagraph class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRParagraph class methodsFor: 'instance-creation' stamp: 'lr 12/9/2007 09:16'!
parse: aString with: aParser
	^ aParser addParagraph: (self withAll: (aParser parseText: aString))! !

!PRParagraph methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitParagraph: self! !

PRDocumentGroup subclass: #PRPreformatted
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRPreformatted commentStamp: 'lr 5/28/2006 20:56' prior: 0!
I am preformatted text or source code. My children are instances of *PRText*.!

!PRPreformatted class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRPreformatted class methodsFor: 'accessing' stamp: 'lr 4/5/2007 13:12'!
markup
	^ '='! !

!PRPreformatted class methodsFor: 'instance-creation' stamp: 'lr 4/24/2007 20:55'!
parse: aString with: aParser
	^ aParser combine: self with: (PRText content: (aString allButFirst: self markup size))! !

!PRPreformatted methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitPreformatted: self! !

PRDocumentGroup subclass: #PRTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRTable commentStamp: 'lr 5/28/2006 20:56' prior: 0!
I am a table. My children are instances of *PRTableRow*.!

!PRTable class methodsFor: 'describing' stamp: 'lr 4/18/2007 23:07'!
descriptionColumnCount
	^ MANumberDescription new
		selectorAccessor: #columnCount;
		label: 'Column Count';
		beReadonly;
		yourself! !

!PRTable class methodsFor: 'describing' stamp: 'lr 4/18/2007 23:07'!
descriptionRowCount
	^ MANumberDescription new
		selectorAccessor: #rowCount;
		label: 'Row Count';
		beReadonly;
		yourself! !

!PRTable class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRTable class methodsFor: 'instance-creation' stamp: 'lr 5/28/2007 16:31'!
parse: aString with: aParser
	| line row cell markup index |
	line := aString.
	row := PRTableRow new.
	[ line isEmpty ] whileFalse: [
		cell := PRTableCell new.
		line := line allButFirst: cell class markup size.
		#(	markupLeft beAlignedLeft
			markupCenter beAlignedCenter
			markupRight beAlignedRight ) pairsDo: [ :selector :align |
				markup := cell class perform: selector.
				(line beginsWith: markup) ifTrue: [
					line := line allButFirst: markup size.
					cell perform: align ] ].
		index := (aParser findFirst: cell class markup at: 1 in: line) - 1.
		index < 1 ifTrue: [ index := line size ].
		row add: (cell addAll: (aParser parseText: (line first: index))).
		line := line allButFirst: index ].
	^ aParser combine: self with: row! !

!PRTable methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitTable: self! !

!PRTable methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
columnCount
	^ self children inject: 0 into: [ :max :row | max max: row columnCount ]! !

!PRTable methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
rowCount
	^ self children size! !

PRDocumentGroup subclass: #PRTableCell
	instanceVariableNames: 'align'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRTableCell commentStamp: 'lr 5/28/2006 20:57' prior: 0!
I am a cell of a table.!

!PRTableCell class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 23:07'!
descriptionAlign
	^ MASingleOptionDescription new
		selectorAccessor: #align;
		label: 'Align';
		options: #(nil #left #center #right );
		yourself! !

!PRTableCell class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRTableCell class methodsFor: 'accessing' stamp: 'lr 4/5/2007 13:13'!
markup
	^ '|'! !

!PRTableCell class methodsFor: 'accessing' stamp: 'lr 4/5/2007 16:11'!
markupCenter
	^ '|'! !

!PRTableCell class methodsFor: 'accessing' stamp: 'lr 4/5/2007 16:11'!
markupLeft
	^ '{'! !

!PRTableCell class methodsFor: 'accessing' stamp: 'lr 4/5/2007 16:11'!
markupRight
	^ '}'! !

!PRTableCell methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
= anObject
	^ super = anObject
		and: [ self align = anObject align ]! !

!PRTableCell methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitTableCell: self! !

!PRTableCell methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
align
	^ align! !

!PRTableCell methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
align: aSymbol
	align := aSymbol! !

!PRTableCell methodsFor: 'actions' stamp: 'lr 3/9/2006 11:30'!
beAlignedCenter
	self align: #center! !

!PRTableCell methodsFor: 'actions' stamp: 'lr 3/9/2006 11:30'!
beAlignedLeft
	self align: #left! !

!PRTableCell methodsFor: 'actions' stamp: 'lr 3/9/2006 11:30'!
beAlignedRight
	self align: #right! !

!PRTableCell methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
hash
	^ super hash bitXor: self align hash! !

!PRTableCell methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAligned
	^ self align notNil! !

!PRTableCell methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAlignedCenter
	^ self align = #center! !

!PRTableCell methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAlignedLeft
	^ self align = #left! !

!PRTableCell methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAlignedRight
	^ self align = #right! !

PRDocumentGroup subclass: #PRTableRow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRTableRow commentStamp: 'lr 5/28/2006 20:56' prior: 0!
I am a row of a table. My children are instances of *PRTableCell*.!

!PRTableRow class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 19:01'!
descriptionColumnCount
	^ ((MANumberDescription new)
		selectorAccessor: #columnCount;
		label: 'Column Count';
		yourself) beReadonly! !

!PRTableRow class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRTableRow methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitTableRow: self! !

!PRTableRow methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
columnCount
	^ self children size! !

!PRDocumentItem class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 23:03'!
descriptionHasChildren
	^ MABooleanDescription new
		selectorAccessor: #hasChildren;
		label: 'Has Children';
		beReadonly;
		yourself! !

!PRDocumentItem class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 23:03'!
descriptionHasOwner
	^ MABooleanDescription new
		selectorAccessor: #hasOwner;
		label: 'Has Owner';
		beReadonly;
		yourself! !

!PRDocumentItem class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 23:04'!
descriptionOwner
	^ PRStructureDescription new
		selectorAccessor: #owner;
		label: 'Owner';
		beReadonly;
		yourself! !

!PRDocumentItem class methodsFor: 'accessing-description' stamp: 'lr 4/18/2007 23:04'!
descriptionText
	^ MAStringDescription new
		selectorAccessor: #text;
		label: 'Text';
		beReadonly;
		yourself! !

!PRDocumentItem class methodsFor: 'instance-creation' stamp: 'lr 4/24/2007 20:37'!
parse: aString with: aParser
	self error: self name , ' is not supposed to be parsed by ' , aParser printString! !

!PRDocumentItem methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= anObject
	^ self species = anObject species! !

!PRDocumentItem methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitDocumentItem: self! !

!PRDocumentItem methodsFor: 'enumerating' stamp: 'lr 4/18/2007 13:45'!
allChildrenDo: aBlock
	"Iterate over all the children of the receiver recurisvely."! !

!PRDocumentItem methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasChildren
	^ false! !

!PRDocumentItem methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasOwner
	^ self owner notNil! !

!PRDocumentItem methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ self species hash! !

!PRDocumentItem methodsFor: 'testing' stamp: 'lr 4/16/2007 12:00'!
isLink
	^ false! !

!PRDocumentItem methodsFor: 'accessing' stamp: 'lr 4/10/2007 21:48'!
owner
	"Answer the object owning the receiver. The default implementation doesn't know about its owner and therefore always returns ==nil==."

	^ nil! !

!PRDocumentItem methodsFor: 'accessing' stamp: 'lr 5/28/2006 20:30'!
owner: anObject! !

!PRDocumentItem methodsFor: 'accessing-dynamic' stamp: 'lr 5/28/2006 20:31'!
text
	"Answer a string representation of the receiver."

	^ String new! !

PRDocumentItem subclass: #PRHorizontalRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRHorizontalRule commentStamp: 'lr 5/28/2006 20:57' prior: 0!
I am a horizontal rule.!

!PRHorizontalRule class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRHorizontalRule class methodsFor: 'accessing' stamp: 'lr 4/5/2007 13:13'!
markup
	^ '_'! !

!PRHorizontalRule class methodsFor: 'instance-creation' stamp: 'lr 4/24/2007 21:01'!
parse: aString with: aParser
	| index |
	index := aString findLast: [ :char | char isSeparator not ].
	^ self markup size < index
		ifFalse: [ aParser add: self new ]
		ifTrue: [ aParser class lineMatcherDefault parse: aString with: aParser ]! !

!PRHorizontalRule methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitHorizontalRule: self! !

PRDocumentItem subclass: #PRLineBreak
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRLineBreak class methodsFor: 'testing' stamp: 'lr 12/9/2007 09:19'!
isAbstract
	^ false! !

!PRLineBreak methodsFor: 'visiting' stamp: 'lr 12/9/2007 09:05'!
accept: aVisitor
	aVisitor visitLineBreak: self! !

PRDocumentItem subclass: #PRText
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRText commentStamp: 'lr 5/28/2006 20:58' prior: 0!
I am a plain text. I am the most important leaf node of the document composite.!

!PRText class methodsFor: 'instance-creation' stamp: 'lr 4/5/2007 14:41'!
content: aString
	^ self new text: aString! !

!PRText class methodsFor: 'accessing-configuration' stamp: 'lr 4/18/2007 19:01'!
descriptionText
	^ (MAStringDescription new)
		selectorAccessor: #text;
		label: 'Text';
		yourself! !

!PRText class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRText methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
= anObject
	^ super = anObject
		and: [ self text = anObject text ]! !

!PRText methodsFor: 'visiting' stamp: 'lr 3/30/2007 20:01'!
accept: aVisitor
	aVisitor visitText: self! !

!PRText methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
hash
	^ super hash bitXor: self text hash! !

!PRText methodsFor: 'printing' stamp: 'lr 3/9/2006 11:30'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' text: '; print: self text! !

!PRText methodsFor: 'accessing' stamp: 'lr 4/5/2007 14:40'!
text
	"Answer the string the receiver is representing."

	^ text! !

!PRText methodsFor: 'accessing' stamp: 'lr 4/5/2007 14:40'!
text: aString
	text := aString! !

PRObject subclass: #PRKernel
	instanceVariableNames: 'name root persistency'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Kernel'!

PRKernel class
	instanceVariableNames: 'Instances'!

!PRKernel commentStamp: 'lr 6/2/2006 10:33' prior: 0!
I am the kernel of Pier. Several instances of myself might exist at the same time, but they all exist independently and don't share any data. I know the root structure and the persistency strategy of the whole data-model. Moreover I prevent any concurrent modifications to the model by providing a global mutex.!

PRKernel class
	instanceVariableNames: 'Instances'!

!PRKernel class methodsFor: 'configuration' stamp: 'lr 1/17/2007 11:04'!
defaultInfo
	^ (PRPage named: 'information')
		addChild: self defaultInfoIntroduction;
		addChild: self defaultInfoSyntax;
		addChild: self defaultInfoLicense;
		contents: '-*Introduction>introduction*
-*Syntax>syntax*
-*License>license*';
		yourself! !

!PRKernel class methodsFor: 'configuration' stamp: 'lr 7/14/2007 09:04'!
defaultInfoIntroduction
	^ (PRPage named: 'introduction')
		contents: 'Pier is a powerful and extensible implementation of a meta-described content management and Wiki system, written with objects from top to bottom:

-''''Object-Oriented Design:'''' Pier features a fully object oriented and meta-described domain model built using Magritte. The content of the pages is parsed and stored as a tree of different entities representing text, links, tables, lists, formattings, etc.
-''''Extensibility:'''' Everything in Pier can be extended: page types, storage mechanism, actions, security mechanism, web-server, etc. Plug-ins can be shared within the community and loaded independently of each other into the system.
-''''Open Source:'''' Pier is released under the MIT license which grants unrestricted rights to copy, modify, and redistribute as long as the original copyright and license terms are retained.
-''''Test Suites:'''' Pier is heavily tested. There are more than 1200 unit tests included with the core of Pier. This makes it easy to change and verify the code and comes in extremely useful when porting Pier to other Smalltalk dialects or when writing extensions.

Up to date information about *Pier>http://www.lukas-renggli.ch/smalltalk/pier* and *Magritte>http://www.lukas-renggli.ch/smalltalk/magritte* can be obtained through their respective web sites.

!!Development
- *Code Repository>http://source.lukas-renggli.ch/pier.html*
- *Report Issue>http://bugs.squeak.org/set_project.php?project_id=9&make_default=no&ref=bug_report_page.php*

!!Mailing-Lists
- *Magritte, Pier and Related Tools>https://www.iam.unibe.ch/mailman/listinfo/smallwiki*
- *Seaside -- The Squeak Enterprise Aubergines Server>http://lists.squeakfoundation.org/cgi-bin/mailman/listinfo/seaside*

!!Documentation
- *Pier Wiki>http://smallwiki.unibe.ch/smallwiki/pier/* (Currently hosted on its predecessor SmallWiki)
- *Magritte -- Meta-Described Web Application Development>http://www.iam.unibe.ch/~scg/Archive/Diploma/Reng06a.pdf* (Chapter 3)';
		yourself! !

!PRKernel class methodsFor: 'configuration' stamp: 'lr 9/13/2007 21:00'!
defaultInfoLicense
	^ (PRPage named: 'license')
		contents: '!!' , MAObject license;
		yourself! !

!PRKernel class methodsFor: 'configuration' stamp: 'lr 1/10/2008 16:45'!
defaultInfoSyntax
	^ (PRPage named: 'syntax')
		contents: '!!Paragraphs
A single newline has no effect on the layout. An empty line starts a new paragraph.

!!Sections
A line starting with ==!!==s becomes a section heading. Use multiple ==!!== to create a subsection. Don''t skip levels. The software can automatically generate a table of contents from headings. 

!!Horizontal Line
A line starting with ==_== (underline) becomes a horizontal line. This is often used to separate topics.

!!Lists
Lines starting with ==#==, ==-==, ==;== or ==:== create a list:
-A block of lines, where each line starts with ==-== is transformed into a bulleted list, where each line is an entry.
-A block of lines, where each line starts with ==#== is transformed into an ordered list, where each line is an entry.
-A block of lines, where each line starts with ==;== or ==:== is transformed into a definition list, where the keyword is prepended with ==;== and the definition with ==:==. Keywords and definitions can be mixed arbitrary.
Lists can be nested. Thus, a line starting with ==#-== is an element of a bulleted list that is part of an ordered list.

!!Tables
To create a table, start off the lines with ==|== and separate the elements with ==|==s. Each new line represents a new row of the table. The contents of cells can be aligned left, centered or aligned right by using ==|{==, ==||== or ==|}== respectively.

!!Preformatted
To create a preformatted section, begin each line with =====. A preformatted section uses equally spaced text so that spacing is preserved.

!!Links
To create a link, put it between ==\*==s. All links have the following form ==\*reference\*== or ==\*alias>reference\*==, where the reference is depending on the kind of link that is created. The contents of some links, e.g. links pointing to image-files, can be embedded into the current document by using ==\+==s: ==\+reference\+==. However not all types of links support embedding and will quietly ignore it.

!!!!Internal Links
If a structure with the given title exists in the wiki (e.g. ==\*Path\*==), a link to that item shows up when the page is saved. In case the path points to an non-existing structure, the user will be offered the possibility to create a new one when clicking on the link. The path can be any absolute or relative  reference within the wiki.

!!!!External Links
-If the link is an URL (e.g. ==\*http://www.lukas-renggli.ch\*==), a link to the external page shows up.
-If the link is an e-mail address (e.g. ==\*renggli@gmail.com\*==), a link to mail that person shows up.
-If the link is an ISBN number (e.g. ==\*isbn:3446202102\*==), a link to the given book shows up.
-If the link is an RFC number (e.g. ==\*rfc:2616\*==), a link to the given RFC page shows up.

!!Formatting
There is some sugar for basic font formattings:
-To make something ""bold"", surround it with ==\""==
-To make something ''''italic'''', surround it with ==\''''==
-To make something ==monospaced==, surround it with ==\====
-To make something --strikethrough--, surround it with ==\--==
-To make something @@subscript@@, surround it with ==\@@==
-To make something ^^superscript^^, surround it with ==\^^==
-To make something __underlined__, surround it with ==\__==';
		yourself! !

!PRKernel class methodsFor: 'configuration' stamp: 'lr 1/17/2007 11:04'!
defaultRoot
	^ (PRPage named: 'pier')
		addChild: self defaultInfo;
		contents: 'Welcome to Pier (formerly called SmallWiki 2), the next generation of a fully extensible content management system implemented in Smalltalk. To read additional information, please consult the *information page>information*.';
		yourself! !

!PRKernel class methodsFor: 'initialization' stamp: 'lr 9/13/2007 21:59'!
initialize
	MACompatibility openWorkspace: MAObject license titled: 'Pier License'! !

!PRKernel class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
instanceNamed: aString
	^ self instances detect: [ :each | each name = aString ]! !

!PRKernel class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
instances
	^ Instances ifNil: [ Instances := Set new ]! !

!PRKernel class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRKernel class methodsFor: 'instance-creation' stamp: 'lr 1/17/2007 11:05'!
named: aString
	^ self named: aString root: self defaultRoot! !

!PRKernel class methodsFor: 'instance-creation' stamp: 'lr 1/17/2007 11:05'!
named: aString root: aStructure
	^ self instances add: (self new
		name: aString;
		root: aStructure;
		yourself)! !

!PRKernel class methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
reset
	"This method is for development and testing purpose only, you should not call it directly unless you want to loose your wiki-kernels."

	(PRCompatibility confirm: 'Are you sure to drop all kernel instances?')
		ifTrue: [ Instances := nil ]! !

!PRKernel methodsFor: 'configuration' stamp: 'lr 9/13/2007 22:00'!
defaultName
	^ 'Pier'! !

!PRKernel methodsFor: 'configuration' stamp: 'lr 1/29/2008 08:59'!
defaultPersistency
	^ PRHistoryPersistency new! !

!PRKernel methodsFor: 'initialization' stamp: 'lr 1/17/2007 11:03'!
initialize
	super initialize.
	self name: self defaultName.
	self persistency: self defaultPersistency! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 1/16/2007 22:45'!
name
	"Answer the name of the kernel."

	^ name! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:10'!
name: aString
	name := aString! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 1/16/2007 22:44'!
persistency
	"Answer the persistency strategy of the receiver."

	^ persistency! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 3/5/2007 14:02'!
persistency: aPersistency
	aPersistency ifNil: [ PRPersistencyError signal: 'A persistency strategy is required.' ].
	persistency ifNotNil: [ persistency setKernel: nil ].
	persistency := aPersistency setKernel: self! !

!PRKernel methodsFor: 'printing' stamp: 'lr 3/9/2006 11:29'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' name: '; print: self name! !

!PRKernel methodsFor: 'actions' stamp: 'lr 4/20/2007 08:31'!
realize
	^ self persistency realizeKernel! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 1/16/2007 22:45'!
root
	"Answer the root structure of the kernel."

	^ root! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:10'!
root: aStructure
	root := aStructure! !

!PRObject class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ true! !

!PRObject class methodsFor: 'instance-creation' stamp: 'lr 5/5/2006 19:19'!
new
	"Create a new instance of this class and checks if it isn't abstract."

	self isAbstract ifTrue: [ self error: self name , ' is abstract.' ].
	^ self basicNew initialize! !

!PRObject class methodsFor: 'reflection' stamp: 'lr 3/9/2006 11:30'!
withAllConcreteClasses
	^ Array streamContents: [ :stream |
		self withAllConcreteClassesDo: [ :each |
			stream nextPut: each ] ]! !

!PRObject class methodsFor: 'reflection' stamp: 'lr 3/9/2006 11:30'!
withAllConcreteClassesDo: aBlock
	self withAllSubclassesDo: [ :each |
		each isAbstract ifFalse: [
			aBlock value: each ] ]! !

!PRObject methodsFor: 'visiting' stamp: 'lr 4/10/2007 21:49'!
accept: aVisitor
	"Dispatch to ==aVisitor== depending on the receiver."! !

!PRObject methodsFor: 'private' stamp: 'lr 3/5/2007 14:03'!
errorPropertyNotFound: aSelector
	MAPropertyError signal: 'Property ' , aSelector , ' not found.'! !

!PRObject methodsFor: 'testing' stamp: 'lr 4/10/2007 21:49'!
hasProperty: aKey
	"Test if the property ==aKey== is defined within the receiver."

	^ self properties includesKey: aKey! !

!PRObject methodsFor: 'initialization' stamp: 'lr 5/5/2006 19:20'!
initialize! !

!PRObject methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopy
	super postCopy.
	properties := properties copy! !

!PRObject methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopyTo: anObject! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 5/28/2006 17:01'!
properties
	"Answer the property dictionary of the receiver."

	^ properties ifNil: [ properties := Dictionary new ]! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 4/10/2007 21:49'!
propertyAt: aKey
	"Answer the value of the property ==aKey==, raises an error if the property doesn't exist."

	^ self propertyAt: aKey ifAbsent: [ self errorPropertyNotFound: aKey ]! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 4/10/2007 21:49'!
propertyAt: aKey ifAbsent: aBlock
	"Answer the value of the property ==aKey==, or the result of ==aBlock== if the property doesn't exist."

	^ self properties at: aKey ifAbsent: aBlock! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 4/10/2007 21:49'!
propertyAt: aKey ifAbsentPut: aBlock
	"Answer the value of the property ==aKey==, or if the property doesn't exist adds and answers the result of evaluating ==aBlock==."

	^ self properties at: aKey ifAbsentPut: aBlock! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 4/10/2007 21:50'!
propertyAt: aKey put: aValue
	"Adds or replaces the property ==aKey== with ==aValue==."

	^ self properties at: aKey put: aValue! !

PRObject subclass: #PRPersistency
	instanceVariableNames: 'kernel mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Persistence'!

PRPersistency subclass: #PRHistoryPersistency
	instanceVariableNames: 'history historySize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Persistence'!

!PRHistoryPersistency methodsFor: 'actions' stamp: 'lr 1/29/2008 08:13'!
add: aContext
	history addLast: aContext.
	[ history size < historySize ]
		whileFalse: [ history removeFirst ]! !

!PRHistoryPersistency methodsFor: 'enumerating' stamp: 'lr 1/29/2008 08:13'!
do: aBlock
	history do: aBlock! !

!PRHistoryPersistency methodsFor: 'actions' stamp: 'lr 1/29/2008 08:12'!
execute: aCommand
	self mutex critical: [
		self apply: aCommand.
		aCommand isLogged 
			ifTrue: [ self add: aCommand context ] ]! !

!PRHistoryPersistency methodsFor: 'accessing' stamp: 'lr 1/29/2008 08:14'!
historySize
	^ historySize! !

!PRHistoryPersistency methodsFor: 'accessing' stamp: 'lr 1/29/2008 08:14'!
historySize: anInteger
	historySize := anInteger! !

!PRHistoryPersistency methodsFor: 'initialization' stamp: 'lr 1/29/2008 08:15'!
initialize
	super initialize.
	historySize := 1024! !

!PRHistoryPersistency methodsFor: 'enumerating' stamp: 'lr 1/29/2008 08:13'!
reverseDo: aBlock
	history reverseDo: aBlock! !

!PRHistoryPersistency methodsFor: 'initialization' stamp: 'lr 1/29/2008 08:13'!
setKernel: aKernel
	super setKernel: aKernel.
	history := OrderedCollection new! !

PRPersistency subclass: #PRNullPersistency
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Persistence'!

!PRNullPersistency methodsFor: 'enumerating' stamp: 'lr 1/17/2007 10:41'!
do: aBlock
	"There is no history for now."! !

!PRPersistency class methodsFor: 'testing' stamp: 'lr 1/16/2007 22:11'!
isAbstract
	^ self name = #PRPersistency! !

!PRPersistency methodsFor: 'protected' stamp: 'lr 2/12/2007 19:07'!
apply: aCommand
	"This method should not be called directly. It performs the basic execution of aCommand in the context of the receiver."

	aCommand isChecked
		ifTrue: [ aCommand doValidate ].
	aCommand doExecute! !

!PRPersistency methodsFor: 'configuration' stamp: 'lr 1/16/2007 22:12'!
defaultMutex
	^ Semaphore forMutualExclusion! !

!PRPersistency methodsFor: 'enumerating' stamp: 'lr 3/9/2006 11:29'!
do: aBlock
	"Evaluates aBlock in chronological order for every item in the history of the kernel."

	self subclassResponsibility! !

!PRPersistency methodsFor: 'enumerating' stamp: 'lr 3/9/2006 11:29'!
do: aBlock for: aStructure
	"Evaluates aBlock in chronological order for every item in the history of aStructure. Subclasses might want to override the default implementation for efficiency."

	self do: [ :each |
		each structure = aStructure
			ifTrue: [ aBlock value: each ] ]! !

!PRPersistency methodsFor: 'actions' stamp: 'lr 4/10/2007 21:50'!
execute: aCommand
	"Execute aCommand using the persistency of the receiver. Subclasses might override this method, e.g. to create a transitional logic or to commit changes after execution. Make sure that you always perform the method ==#apply:== when overriding this code."

	self mutex critical: [ self apply: aCommand ]! !

!PRPersistency methodsFor: 'conveniance' stamp: 'lr 3/9/2006 11:29'!
history
	^ Array streamContents: [ :stream |
		self do: [ :each |
			stream nextPut: each ] ]! !

!PRPersistency methodsFor: 'conveniance' stamp: 'lr 3/9/2006 11:29'!
historyFor: aStructure
	^ Array streamContents: [ :stream |
		self
			do: [ :each | stream nextPut: each ]
			for: aStructure ]! !

!PRPersistency methodsFor: 'initialization' stamp: 'lr 1/16/2007 22:10'!
initialize
	super initialize.
	mutex := self defaultMutex! !

!PRPersistency methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
kernel
	^ kernel! !

!PRPersistency methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:07'!
mutex
	"Return a mutex (an object that understands #critical:) to ensure that only one process is modifying the model at once. This is needed to make certain that the model remains in a consistent state. All write access must go through this mutex."

	^ mutex! !

!PRPersistency methodsFor: 'actions' stamp: 'lr 5/28/2007 16:31'!
realizeKernel
	^ self kernel! !

!PRPersistency methodsFor: 'enumerating' stamp: 'lr 3/9/2006 11:29'!
reverseDo: aBlock
	"Evaluates aBlock in inverse chronological order for every item in the history of aStructure. Subclasses might want to override the default implementation for efficiency."

	self history reverseDo: aBlock! !

!PRPersistency methodsFor: 'enumerating' stamp: 'lr 3/9/2006 11:29'!
reverseDo: aBlock for: aStructure
	"Evaluates aBlock in inverse chronological order for every item in the history of aStructure. Subclasses might want to override the default implementation for efficiency."

	(self historyFor: aStructure)
		reverseDo: aBlock! !

!PRPersistency methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setKernel: aKernel
	kernel := aKernel! !

Object subclass: #PRVisitor
	instanceVariableNames: 'escaper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRVisitor commentStamp: 'lr 6/2/2006 11:55' prior: 0!
I am an abstract visitor. I provide a default implementation of all visit messages that does not descend automatically into children of the visited graph. Subclasses should override all my messages in appropriate ways to visit the nodes they need.!

PRVisitor subclass: #PRDocumentWriter
	instanceVariableNames: 'stream nesting newline'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDocumentWriter commentStamp: 'lr 6/1/2006 21:17' prior: 0!
I am a visitor being able to transform a composite of document-items back into the original Wiki string.

!!Example
=| document |
=document := PRDocumentParser parse: '+Hello+ *World*'.
=string := PRDocumentWriter write: document.
=string inspect.!

!PRDocumentWriter class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
write: anObject
	^ self new write: anObject! !

!PRDocumentWriter class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
write: anObject to: aStream
	^ self new write: anObject to: aStream! !

!PRDocumentWriter methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:29'!
contents
	^ stream contents! !

!PRDocumentWriter methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
defaultStream
	^ String new writeStream! !

!PRDocumentWriter methodsFor: 'private' stamp: 'lr 4/5/2007 14:07'!
nest: aString do: aBlock
	nesting add: aString.
	aBlock ensure: [ nesting removeLast ]! !

!PRDocumentWriter methodsFor: 'private' stamp: 'lr 12/20/2007 19:45'!
newLine
	stream nextPut: Character cr.
	newline := true! !

!PRDocumentWriter methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:29'!
nextPut: aCharacter
	stream nextPut: aCharacter.
	newline := false! !

!PRDocumentWriter methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:29'!
nextPutAll: aString
	stream nextPutAll: aString.
	newline := false! !

!PRDocumentWriter methodsFor: 'visiting' stamp: 'lr 12/20/2007 14:28'!
start: anObject
	newline := true.
	nesting := OrderedCollection new.
	super start: anObject.
	(stream isEmpty not and: [ stream last = Character cr ])
		ifTrue: [ stream skip: -1 ]! !

!PRDocumentWriter methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
stream
	^ stream! !

!PRDocumentWriter methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
stream: aStream
	stream := aStream! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 20:09'!
visitLineBreak: anObject
	self newLine! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 14:23'!
visitParagraph: anObject
	super visitParagraph: anObject.
	self newLine! !

!PRDocumentWriter methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
write: anObject
	^ self write: anObject to: self defaultStream! !

!PRDocumentWriter methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
write: anObject to: aStream
	^ self stream: aStream; start: anObject; contents! !

PRDocumentWriter subclass: #PRTextWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/30/2007 23:25'!
visitDataItem: anObject
	self nest: ' ' do: [ super visitDataItem: anObject ]! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/30/2007 23:24'!
visitDefinitionList: anObject
	newline ifFalse: [ self newLine ].
	self visitAll: anObject children! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 14:22'!
visitHeader: anObject
	super visitHeader: anObject.
	self newLine! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 14:22'!
visitHorizontalRule: anObject
	self nextPutAll: (String new: 40 withAll: $-); newLine! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 2/7/2007 15:04'!
visitLink: anObject
	anObject hasAlias
		ifTrue: [ super visitLink: anObject ]
		ifFalse: [ self nextPutAll: anObject title ]! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 20:06'!
visitListItem: anObject
	nesting last isInteger
		ifTrue: [ nesting addLast: nesting removeLast + 1 ].
	nesting size - 1 timesRepeat: [ stream tab ].
	self nextPutAll: nesting last asString.
	self nextPutAll: (nesting last isInteger 
		ifTrue: [ '. ' ] ifFalse: [ ' ' ]).
	super visitListItem: anObject.
	newline ifFalse: [ self newLine ]! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 19:59'!
visitOrderedList: anObject
	newline ifFalse: [ self newLine ].
	self nest: 0 do: [ super visitOrderedList: anObject ]! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 19:56'!
visitPreformatted: anObject
	anObject children do: [ :each | self visit: each; newLine ]! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 14:22'!
visitTableRow: anObject
	anObject children
		do: [ :each | self visit: each ]
		separatedBy: [ self nextPut: Character tab ].
	self newLine! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/30/2007 23:24'!
visitTermItem: anObject
	self nest: '-' do: [ super visitDataItem: anObject ]! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 2/6/2007 18:55'!
visitText: anObject
	self nextPutAll: anObject text! !

!PRTextWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 19:54'!
visitUnorderedList: anObject
	newline ifFalse: [ self newLine ].
	self nest: '*' do: [ super visitUnorderedList: anObject ]! !

PRDocumentWriter subclass: #PRWikiWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRWikiWriter methodsFor: 'accessing' stamp: 'lr 4/5/2007 13:07'!
lineMatcher
	^ PRDocumentParser lineMatcher! !

!PRWikiWriter methodsFor: 'accessing' stamp: 'lr 4/5/2007 13:07'!
textMatcher
	^ PRDocumentParser textMatcher! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 14:19'!
visitAnchor: anObject
	self nextPutAll: anObject class markup; nextPutAll: anObject name; newLine! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 12/30/2007 21:59'!
visitDefinitionList: anObject
	newline ifFalse: [ self newLine ].
	anObject children do: [ :each |
		self 
			nest: each class markup
			do: [ self visit: each ] ]! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:08'!
visitFormat: anObject
	self nextPutAll: anObject class markup.
	super visitFormat: anObject.
	self nextPutAll: anObject class markup! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 14:20'!
visitHeader: anObject
	anObject level timesRepeat: [ self nextPutAll: anObject class markup ].
	super visitHeader: anObject.
	self newLine! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 14:20'!
visitHorizontalRule: anObject
	self nextPutAll: anObject class markup; newLine! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 9/12/2007 18:18'!
visitLink: anObject
	self nextPutAll: (anObject isEmbedded
		ifFalse: [ anObject class markup ]
		ifTrue: [ anObject class markupEmbedded ]).
	anObject hasAlias ifTrue: [
		super visitLink: anObject.
		self nextPutAll: anObject class markupAlias ].
	self nextPutAll: anObject reference.
	anObject hasAnchor ifTrue: [
		self nextPutAll: anObject class markupAnchor.
		self nextPutAll: anObject anchor ].
	anObject parameters do: [ :assoc |
		self nextPutAll: anObject class markupParameter.
		self nextPutAll: assoc key.
		assoc value isNil
			ifFalse: [ self nextPut: $=; nextPutAll: assoc value ] ].
	self nextPutAll: (anObject isEmbedded
		ifFalse: [ anObject class markup ]
		ifTrue: [ anObject class markupEmbedded ])! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 19:45'!
visitList: anObject
	newline ifFalse: [ self newLine ].
	self nest: anObject class markup do: [ super visitList: anObject ]! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 19:52'!
visitListItem: anObject
	nesting do: [ :each | self nextPutAll: each ].
	super visitListItem: anObject.
	newline ifFalse: [ self newLine ]! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 14:21'!
visitPreformatted: anObject
	anObject children do: [ :each |
		self
			nextPutAll: anObject class markup; 
			nextPutAll: each text;
			newLine ]! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 4/5/2007 16:25'!
visitTableCell: anObject
	self nextPutAll: anObject class markup.
	anObject isAligned ifTrue: [
		anObject isAlignedLeft ifTrue: [ self nextPutAll: anObject class markupLeft ].
		anObject isAlignedCenter ifTrue: [ self nextPutAll: anObject class markupCenter ].
		anObject isAlignedRight ifTrue: [ self nextPutAll: anObject class markupRight ] ].
	super visitTableCell: anObject! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 14:21'!
visitTableRow: anObject
	super visitTableRow: anObject.
	self newLine! !

!PRWikiWriter methodsFor: 'visiting-document' stamp: 'lr 4/5/2007 17:59'!
visitText: anObject
	"Write out ==anObject=='s text to the receivers output-stream and escape special characters within and at the beginning of a line."

	| string key |
	string := anObject text.
	newline ifTrue: [
		key := self lineMatcher keys
			detect: [ :each | string beginsWith: each ]
			ifNone: [ nil ].
		key isNil ifFalse: [
			self nextPut: $\; nextPutAll: key.
			string := string allButFirst: key size ] ].
	self nextPutAll: (PRDocumentParser escape: string)! !

PRVisitor subclass: #PRPath
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRPath class methodsFor: 'accessing' stamp: 'lr 9/27/2007 09:55'!
currentStructure
	^ '.'! !

!PRPath class methodsFor: 'testing' stamp: 'lr 9/27/2007 10:15'!
isValidName: aString
	^ aString isNil not
		and: [ aString isEmpty not
		and: [ aString ~= self currentStructure
		and: [ aString ~= self parentStructure 
		and: [ (aString includes: self pathDelimiter) not ] ] ] ]! !

!PRPath class methodsFor: 'accessing' stamp: 'lr 9/27/2007 09:54'!
parentStructure
	^ '..'! !

!PRPath class methodsFor: 'accessing' stamp: 'lr 9/27/2007 09:55'!
pathDelimiter
	^ $/! !

!PRPath methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
stream
	^ stream! !

!PRPath methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
stream: aStream
	stream := aStream! !

PRPath subclass: #PRPathLookup
	instanceVariableNames: 'pathElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRPathLookup commentStamp: 'lr 5/28/2006 21:19' prior: 0!
I am a visitor used to look up a given path. I am able to lookup absolute and relative paths, following the syntax of unix operating systems.

!!Example
=(PRPathLookup
=	start: aStructure
=	path: '/Information/Copyright/..')
=		inspect!

PRPathLookup subclass: #PRIncompletePathLookup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRIncompletePathLookup class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
start: aStructure path: aString
	| visitor |
	visitor := self new
		stream: aString readStream;
		yourself.
	^ Association
		key: (visitor lookup: aStructure)
		value: visitor pathElement! !

!PRIncompletePathLookup methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
childNotFound: aStructure
	self readNext; escape: aStructure! !

!PRPathLookup class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
start: aStructure path: aString
	^ self new
		stream: aString readStream;
		lookup: aStructure! !

!PRPathLookup class methodsFor: 'instance creation' stamp: 'lr 3/5/2007 13:44'!
start: aStructure path: aString onError: aBlock
	^ [ self start: aStructure path: aString ]
		on: PRChildNotFoundError
		do: [ :error | aBlock value ]! !

!PRPathLookup methodsFor: 'private' stamp: 'lr 3/5/2007 13:43'!
childNotFound: aStructure
	PRChildNotFoundError signal: 'Invalid path ' , self stream contents! !

!PRPathLookup methodsFor: 'actions' stamp: 'lr 9/27/2007 09:57'!
lookup: aStructure
	^ self withEscaper: [
		self stream peek = self class pathDelimiter
			ifTrue: [ self lookupRoot: aStructure ]
			ifFalse: [ self lookupStart: aStructure ].
		self childNotFound: aStructure ]! !

!PRPathLookup methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
lookupRoot: aStructure
	self stream next.
	self visit: aStructure root! !

!PRPathLookup methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
lookupStart: aStructure
	self visit: aStructure! !

!PRPathLookup methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
pathElement
	^ pathElement! !

!PRPathLookup methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
pathElement: aString
	pathElement := aString! !

!PRPathLookup methodsFor: 'private' stamp: 'lr 9/27/2007 09:58'!
readNext
	^ self stream upTo: self class pathDelimiter! !

!PRPathLookup methodsFor: 'visiting-decorations' stamp: 'lr 4/10/2007 21:50'!
visitChildren: anObject
	"This method does the lookup of the next structure by checking for a child with that name, since this value is hashed it can be done efficiently. If the lookup by name fails, it tries to match the title by iterating through the children. If this fails as well, the message ==#childNotFound:== is sent."

	anObject
		at: self pathElement
		ifPresent: [ :value | ^ self visit: value ].
	anObject do: [ :each |
		self pathElement = each title
			ifTrue: [ ^ self visit: each ] ].
	self childNotFound: anObject decorated! !

!PRPathLookup methodsFor: 'visiting-structure' stamp: 'lr 9/27/2007 09:58'!
visitStructure: aStructure
	self stream atEnd
		ifTrue: [ self escape: aStructure ].
	self pathElement: self readNext.
	self pathElement = self class currentStructure
		ifTrue: [ ^ self visit: aStructure ].
	self pathElement = self class parentStructure
		ifTrue: [
			^ self visit: (aStructure isRoot
				ifTrue: [ aStructure ]
				ifFalse: [ aStructure parent ]) ].
	aStructure hasChildren
		ifFalse: [ self childNotFound: aStructure ]! !

PRPath subclass: #PRPathReference
	instanceVariableNames: 'source sourcePath target targetPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRPathReference commentStamp: 'lr 5/28/2006 21:19' prior: 0!
I am a visitor used to print a short path from a structure to another one.

!!Example
=(PRPathReference
=	from: aFirstStructure
=	to: aSecondStructure)
=		inspect!

!PRPathReference class methodsFor: 'instance creation' stamp: 'lr 11/2/2007 13:29'!
from: aFirstStructure to: aSecondStructure
	^ self new
		setSource: aFirstStructure;
		setTarget: aSecondStructure;
		relativeReference! !

!PRPathReference class methodsFor: 'instance creation' stamp: 'lr 11/2/2007 13:30'!
to: aStructure
	^ self new
		setTarget: aStructure;
		absoluteReference! !

!PRPathReference methodsFor: 'actions' stamp: 'lr 11/2/2007 13:32'!
absoluteReference
	self targetPath removeFirst.
	self writeDelimiter.
	self targetPath 	
		do: [ :each | self visit: each ]
		separatedBy: [ self writeDelimiter ].
	^ self stream contents! !

!PRPathReference methodsFor: 'private' stamp: 'lr 9/27/2007 09:42'!
hasCommonPath
	"Answer true if the source and target path start with the same structure."
	
	 ^ self sourcePath notEmpty
		and: [ self targetPath notEmpty
		and: [ self sourcePath first = self targetPath first ] ]! !

!PRPathReference methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
initialize
	super initialize.
	stream := WriteStream on: String new! !

!PRPathReference methodsFor: 'actions' stamp: 'lr 11/2/2007 13:36'!
relativeReference
	self validateKernel.
	self removeCommonPath.
	self source = self target 
		ifTrue: [ ^ self class currentStructure ].
	self sourcePath reverseDo: [ :each |
		self writeParent; writeDelimiter ].
	self targetPath 	
		do: [ :each | self visit: each; writeDelimiter ].
	^ self stream skip: -1; contents
! !

!PRPathReference methodsFor: 'private' stamp: 'lr 9/27/2007 09:44'!
removeCommonPath
	"Remove all common path elements from the source and target path."
	
	[ self hasCommonPath ] whileTrue: [ 
		self sourcePath removeFirst.
		self targetPath removeFirst ]! !

!PRPathReference methodsFor: 'initialization' stamp: 'lr 9/27/2007 09:41'!
setSource: aStructure
	source := aStructure.
	sourcePath := aStructure parents! !

!PRPathReference methodsFor: 'initialization' stamp: 'lr 9/27/2007 09:41'!
setTarget: aStructure
	target := aStructure.
	targetPath := aStructure parents! !

!PRPathReference methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
source
	^ source! !

!PRPathReference methodsFor: 'accessing' stamp: 'lr 9/27/2007 09:41'!
sourcePath
	^ sourcePath! !

!PRPathReference methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
target
	^ target! !

!PRPathReference methodsFor: 'accessing' stamp: 'lr 9/27/2007 09:41'!
targetPath
	^ targetPath! !

!PRPathReference methodsFor: 'private' stamp: 'lr 9/27/2007 09:43'!
validateKernel
	"Validate that the source and target are contained within the same kernel. This is done by comparing the root structure."
	
	self hasCommonPath
		ifFalse: [ PRInvalidKernelError signal: 'Unable to reference external wiki.' ]! !

!PRPathReference methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
visitStructure: aStructure
	stream nextPutAll: aStructure name! !

!PRPathReference methodsFor: 'private-writing' stamp: 'lr 9/27/2007 09:58'!
writeDelimiter
	stream nextPut: self class pathDelimiter! !

!PRPathReference methodsFor: 'private-writing' stamp: 'lr 9/27/2007 09:54'!
writeParent
	stream nextPutAll: self class parentStructure! !

PRVisitor subclass: #PRPluggableVisitor
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

PRPluggableVisitor subclass: #PREnumerableVisitor
	instanceVariableNames: 'structure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

PREnumerableVisitor subclass: #PRChildrenVisitor
	instanceVariableNames: 'with all sortBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRChildrenVisitor methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
all
	"Tell the receiver to visit structures recursively."

	all := true! !

!PRChildrenVisitor methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
all: aBoolean
	all := aBoolean! !

!PRChildrenVisitor methodsFor: 'actions' stamp: 'lr 9/27/2007 10:02'!
everything
	"Tell the receiver to visit everything."

	with := all := true! !

!PRChildrenVisitor methodsFor: 'initialization' stamp: 'lr 9/27/2007 10:02'!
initialize
	super initialize.
	with := all := false.
	sortBlock := [ :a :b | a < b ]! !

!PRChildrenVisitor methodsFor: 'accessing' stamp: 'lr 8/24/2006 22:42'!
sortBlock: aBlock
	sortBlock := aBlock! !

!PRChildrenVisitor methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
start: anObject
	self withEscaper: [ super start: anObject ]! !

!PRChildrenVisitor methodsFor: 'visiting-decoration' stamp: 'lr 9/27/2007 10:10'!
visitChildren: anObject
	(all or: [ structure = anObject decorated ])
		ifFalse: [ ^ self ].
	anObject
		do: [ :each | self visit: each ]
		sorted: sortBlock! !

!PRChildrenVisitor methodsFor: 'visiting-structure' stamp: 'lr 9/27/2007 10:11'!
visitStructure: aStructure
	(with or: [ structure ~= aStructure ])
		ifTrue: [ block value: aStructure ]! !

!PRChildrenVisitor methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
with
	"Tell the receiver to visit the start structure as well."

	with := true! !

!PRChildrenVisitor methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
with: aBoolean
	with := aBoolean! !

!PREnumerableVisitor class methodsFor: 'instance creation' stamp: 'lr 1/21/2007 11:04'!
on: aStructure
	^ self new structure: aStructure! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'lr 10/30/2006 17:13'!
collect: aBlock
	"Evaluate aBlock for every structure visited by the receiver and answer a collection of the results."

	^ Array streamContents: [ :stream |
		self do: [ :each |
			stream nextPut: (aBlock value: each) ] ]! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'lr 1/19/2007 14:07'!
contents
	"Answer a collection of all elements that have been visited."

	^ self collect: [ :each | each ]! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'lr 1/21/2007 10:49'!
do: aBlock
	"Evaluate aBlock for every structure visited by the receiver."

	self setBlock: aBlock; start: structure; setBlock: nil! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'lr 4/5/2007 17:59'!
do: aBlock separatedBy: aSeparatorBlock
	"Evaluate aBlock for every structure visited by the receiver, and evaluate aSeparatorBlock between."

	| first |
	first := true.
	self do: [ :each |
		first
			ifTrue: [ first := false ]
			ifFalse: [ aSeparatorBlock value ].
		aBlock value: each ]! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'lr 4/5/2007 17:59'!
inject: anObject into: aBlock
	"Accumulate a running value associated with evaluating the argument aBlock with the current value of the argument anObject and the receiver as block arguments."

	| next |
	next := anObject.
	self do: [ :each | next := aBlock value: next value: each ].
	^ next! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'lr 4/10/2007 21:49'!
reject: aBlock
	"Evaluate aBlock for every structure visited by the receiver and answer a collection for which aBlock evaluates to ==false==."

	^ self select: [ :each | (aBlock value: each) not ]! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'lr 4/10/2007 21:49'!
select: aBlock
	"Evaluate aBlock for every structure visited by the receiver and answer a collection for which aBlock evaluates to ==true==."

	^ Array streamContents: [ :stream |
		self do: [ :each |
			(aBlock value: each)
				ifTrue: [ stream nextPut: each ] ] ]! !

!PREnumerableVisitor methodsFor: 'accessing' stamp: 'lr 1/21/2007 11:04'!
structure
	^ structure! !

!PREnumerableVisitor methodsFor: 'accessing' stamp: 'lr 1/21/2007 11:04'!
structure: aStructure
	structure := aStructure! !

PREnumerableVisitor subclass: #PRFullTextSearch
	instanceVariableNames: 'subString caseSensitive lastStructure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRFullTextSearch commentStamp: 'lr 4/10/2007 21:12' prior: 0!
I am a pluggable visitor to quickly look for matching text in a subtree of structures.

!!Example
The following example opens an inspector on all structures with the text ==foo==:
=(PRFullTextSearch 
=	from: aStructure
=	find: 'foo'
=	caseSensitive: false)
=		inspect!

!PRFullTextSearch methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:07'!
caseSensitive: aBoolean
	"Set if the search text is case sensitive or not."

	caseSensitive := aBoolean! !

!PRFullTextSearch methodsFor: 'private' stamp: 'lr 12/15/2006 11:44'!
check: aString in: aStructure
	(lastStructure ~= aStructure and: [ aString includesSubstring: subString caseSensitive: caseSensitive ])
		ifTrue: [ block value: (lastStructure := aStructure) ]! !

!PRFullTextSearch methodsFor: 'initialization' stamp: 'lr 10/30/2006 17:25'!
initialize
	super initialize.
	subString := String new.
	caseSensitive := false! !

!PRFullTextSearch methodsFor: 'visiting' stamp: 'lr 10/30/2006 17:19'!
start: anObject
	lastStructure := nil.
	super start: anObject! !

!PRFullTextSearch methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:07'!
subString: aString
	"Set the sub-string to be looked for."

	subString := aString! !

!PRFullTextSearch methodsFor: 'visiting-decoration' stamp: 'lr 3/9/2006 11:29'!
visitChildren: anObject
	self visitAll: anObject children! !

!PRFullTextSearch methodsFor: 'visiting-structure' stamp: 'lr 9/26/2007 19:58'!
visitStructure: aStructure
	aStructure description do: [ :each |
		each isSearchable ifTrue: [
			self
				check: (each toString: (aStructure
					readUsing: each))
				in: aStructure ] ]! !

PREnumerableVisitor subclass: #PRIncomingReferences
	instanceVariableNames: 'structures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRIncomingReferences commentStamp: 'lr 4/10/2007 21:12' prior: 0!
I am a pluggable visitor to detect incoming references.

!!Example
The following example opens inspectors on all instances of ==*PRInternalLink*== that point ==aStructure==:
=aStructure incomingReferences 
=	from: aRootStructure
=	to: aStructure
=	do: [ :each | each inspect ]!

!PRIncomingReferences methodsFor: 'initialization' stamp: 'lr 10/30/2006 20:11'!
initialize
	super initialize.
	structures := Set new! !

!PRIncomingReferences methodsFor: 'accessing' stamp: 'lr 10/30/2006 20:30'!
to: aStructure
	structures add: aStructure! !

!PRIncomingReferences methodsFor: 'accessing' stamp: 'lr 10/30/2006 20:30'!
toAll: aCollection
	structures addAll: aCollection! !

!PRIncomingReferences methodsFor: 'visiting-structure' stamp: 'lr 1/15/2007 21:44'!
visitCase: anObject
	super visitCase: anObject.
	self visit: anObject document! !

!PRIncomingReferences methodsFor: 'visiting-decoration' stamp: 'lr 3/9/2006 11:29'!
visitChildren: anObject
	self visitAll: anObject children! !

!PRIncomingReferences methodsFor: 'visiting-document' stamp: 'lr 10/30/2006 20:12'!
visitInternalLink: anObject
	(structures includes: anObject target)
		ifTrue: [ block value: anObject ]! !

PREnumerableVisitor subclass: #PROutgoingReferences
	instanceVariableNames: 'continue structures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PROutgoingReferences commentStamp: 'lr 4/10/2007 21:12' prior: 0!
I am a pluggable visitor visiting and probably following outgoing references. To do so I visit all the links of the page and evaluate my pluggable block for each of them. If the ==continue== block answers ==true== I follow the link and continue visiting the references of the target structure. The default behavior of the ==continue== block is to follow the link only if it is embedded. I take care not to run into infinite recursion, so no structure will be visited more than once.

!!Examples
The following example answers a collection of referenced pages from ==aStructure==:

=(aStructure outgoingReferences
=	collect: [ :each | each target ])
=		asSet
		
The following example answers a collection of all broken references that can be reached from ==aStructure==:

=aStructure outgoingReferences
=	continue: [ :each | each isBroken not ];
= 	collect: [ :each | each isBroken ]!

!PROutgoingReferences methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:07'!
continue: aBlock
	"A block to decide if the visitor should visit the structure referenced by the link passed into aBlock or not."

	continue := aBlock! !

!PROutgoingReferences methodsFor: 'initialization' stamp: 'lr 1/19/2007 14:05'!
initialize
	super initialize.
	continue := [ :each | each isEmbedded ]! !

!PROutgoingReferences methodsFor: 'visiting' stamp: 'lr 10/30/2006 19:42'!
start: anObject
	structures := Set new.
	super start: anObject! !

!PROutgoingReferences methodsFor: 'visiting-structure' stamp: 'lr 10/17/2007 22:53'!
visitCase: anObject
	super visitCase: anObject.
	self visit: anObject document! !

!PROutgoingReferences methodsFor: 'visiting-document' stamp: 'lr 10/30/2006 19:43'!
visitInternalLink: anObject
	block value: anObject.
	(anObject target isNil or: [ structures includes: anObject target ])
		ifTrue: [ ^ self ].
	(continue value: anObject)
		ifTrue: [ self visit: anObject target ]! !

!PROutgoingReferences methodsFor: 'visiting-structure' stamp: 'lr 10/30/2006 19:43'!
visitStructure: aStructure
	structures add: aStructure! !

!PRPluggableVisitor methodsFor: 'initialization' stamp: 'lr 10/30/2006 16:53'!
setBlock: aBlock
	block := aBlock! !

!PRVisitor class methodsFor: 'building' stamp: 'lr 3/30/2007 19:58'!
buildVisitorHierarchyForClass: aClass selector: aSelectorBlock classified: aClassifiedBlock
	" self buildVisitorHierarchyForClass: PRObject selector: [ :class | 'visit' , (class name allButFirst: 2) , ':' ] classified: [ :class | 'visiting-' , (class category copyAfterLast: $-) asLowercase ] "

	aClass withAllSubclassesDo: [ :class |
		(class category beginsWith: 'Pier-Model') ifTrue: [
			(self selectors includes: (aSelectorBlock value: class)) ifFalse: [
				self
					compile: (String streamContents: [ :stream |
						stream nextPutAll: (aSelectorBlock value: class); nextPutAll: ' anObject'; cr.
						class = aClass ifFalse: [
							stream tab; nextPutAll: 'self '; nextPutAll: (aSelectorBlock value: class superclass); nextPutAll: ' anObject' ] ])
					classified: (aClassifiedBlock value: class) ].
			class
				compile: (String streamContents: [ :stream |
					stream nextPutAll: 'accept: aVisitor'; cr.
					stream tab; nextPutAll: 'aVisitor '; nextPutAll: (aSelectorBlock value: class); nextPutAll: ' self' ])
				classified: #visiting ] ]! !

!PRVisitor class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
visit: anObject
	^ self new
		start: anObject;
		yourself! !

!PRVisitor methodsFor: 'escaping' stamp: 'lr 3/9/2006 11:30'!
escape: anObject
	escaper value: anObject! !

!PRVisitor methodsFor: 'escaping' stamp: 'lr 3/9/2006 11:30'!
hasEscaper
	^ escaper notNil! !

!PRVisitor methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
start: anObject
	self visit: anObject! !

!PRVisitor methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
visit: anObject
	anObject acceptDecorated: self! !

!PRVisitor methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
visitAll: aCollection
	aCollection do: [ :each | self visit: each ]! !

!PRVisitor methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
visitAll: aCollection separatedBy: aBlock
	aCollection do: [ :each | self visit: each ] separatedBy: aBlock! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitAnchor: anObject
	self visitDocumentItem: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitBoldFormat: anObject
	self visitFormat: anObject! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 3/30/2007 20:01'!
visitCase: anObject
	self visitStructure: anObject! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 10/16/2007 22:28'!
visitChildren: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 12/30/2007 21:53'!
visitDataItem: anObject
	self visitListItem: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 12/30/2007 19:33'!
visitDefinitionList: anObject
	self visitList: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitDocument: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:05'!
visitDocumentGroup: anObject
	self visitAll: anObject children! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:04'!
visitDocumentItem: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 12/20/2007 12:13'!
visitEmptyParagraph: anObject
	self visitParagraph: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitExternalLink: anObject
	self visitLink: anObject! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 3/30/2007 20:01'!
visitFile: anObject
	self visitStructure: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitFormat: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitGoogleLink: anObject
	self visitExternalLink: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitHeader: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitHorizontalRule: anObject
	self visitDocumentItem: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitInternalLink: anObject
	self visitLink: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitIsbnLink: anObject
	self visitExternalLink: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitItalicFormat: anObject
	self visitFormat: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 12/30/2007 19:56'!
visitLineBreak: anObject
	self visitDocumentItem: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitLink: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitList: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitListItem: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitMailLink: anObject
	self visitExternalLink: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitMonospaceFormat: anObject
	self visitFormat: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitOrderedList: anObject
	self visitList: anObject! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 3/30/2007 20:01'!
visitPage: anObject
	self visitCase: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitParagraph: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitPreformatted: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitRfcLink: anObject
	self visitExternalLink: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 5/31/2007 07:46'!
visitStrikethroughFormat: anObject
	self visitFormat: anObject! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 10/16/2007 22:26'!
visitStructure: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitSubscriptFormat: anObject
	self visitFormat: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitSuperscriptFormat: anObject
	self visitFormat: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitTable: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitTableCell: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitTableRow: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 12/30/2007 21:53'!
visitTermItem: anObject
	self visitListItem: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitText: anObject
	self visitDocumentItem: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitUnderlineFormat: anObject
	self visitFormat: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/30/2007 20:01'!
visitUnorderedList: anObject
	self visitList: anObject! !

!PRVisitor methodsFor: 'escaping' stamp: 'lr 3/9/2006 11:30'!
withEscaper: aBlock
	| old |
	old := escaper.
	escaper := [ :value | ^ value ].
	^ aBlock ensure: [ escaper := old ]! !

!UndefinedObject methodsFor: '*pier-model' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	"do nothing"! !

!MAStringWriter methodsFor: '*pier-model-visiting' stamp: 'lr 10/16/2007 20:11'!
visitDocumentDescription: aDescription
	aDescription writerClass 
		write: self object
		to: self stream! !

!MAStringWriter methodsFor: '*pier-model-visiting' stamp: 'lr 11/2/2007 13:50'!
visitStructureDescription: aDescription
	stream nextPutAll: (PRPathReference to: self object)! !
PRDocumentParser initialize!
PRMacroExpander initialize!
PRMigrations initialize!
PRKernel initialize!
